package ext.app.bind {
import ext.util.Schedulable;

[Uses("ext.util.Schedulable")]
[Uses("ext.Base")]
[Native("Ext.app.bind.BaseBinding", require)]
[ExcludeClass]
/**
 * This class is the base for <code>Binding</code> and <code>MultiBinding</code>.
 */
public class BaseBinding extends ext.util.Schedulable {
  /**
   * @param config @inheritDoc
   */
  public function BaseBinding(config:ext.app.bind.BaseBinding = null) {
    super();
  }

  [ExtConfig]
  /**
   * This option instructs the binding to call its <code>destroy</code> method immediately after
   * delivering the initial value.
   * @default false
   * @since 5.0.0
   */
  public native function get single():Boolean;

  [ExtConfig]
  /**
   * @private
   */
  public native function set single(value:Boolean):void;
}
}