package ext {
import ext.env.Browser;

[Uses("ext.env.Browser")]
[Native("Ext.browser")]
/**
 * Provides useful information about the current browser.
 *
 * <p>Example:</p>
 *
 * <pre><code>if (Ext.browser.is.IE) {
 *     // IE specific code here
 * }
 *
 * if (Ext.browser.is.WebKit) {
 *     // WebKit specific code here
 * }
 *
 * console.log("Version " + <a href="#!/api/Ext.browser-property-version" rel="Ext.browser-property-version" class="docClass">Ext.browser.version</a>);
 * </code></pre>
 *
 * <p>For a full list of supported values, refer to <a href="#!/api/Ext.browser-method-is" rel="Ext.browser-method-is" class="docClass">is</a> property/method.</p>
 */
public const browser:ext.env.Browser;
}