package ext.data {

[Uses("ext.data.SStoreManager")]
[Uses("ext.util.MixedCollection")]
[Uses("ext.util.AbstractMixedCollection")]
[Uses("ext.mixin.Observable")]
[Uses("ext.Base")]
[Uses("ext.util.Sortable")]
[Native("Ext.data.StoreManager", require)]
/**
 * Contains a collection of all stores that are created that have an identifier. An identifier can be assigned by
 * setting the <a href="#!/api/Ext.data.AbstractStore-cfg-storeId" rel="Ext.data.AbstractStore-cfg-storeId" class="docClass">storeId</a> property. When a store is in the StoreManager, it can be
 * referred to via it's identifier:
 *
 * <pre><code><a href="#!/api/Ext-method-create" rel="Ext-method-create" class="docClass">Ext.create</a>('<a href="#!/api/Ext.data.Store" rel="Ext.data.Store" class="docClass">Ext.data.Store</a>', {
 *     model: 'SomeModel',
 *     storeId: 'myStore'
 * });
 *
 * var store = <a href="#!/api/Ext.data.StoreManager-method-lookup" rel="Ext.data.StoreManager-method-lookup" class="docClass">Ext.data.StoreManager.lookup</a>('myStore');
 * </code></pre>
 *
 * <p>Also note that the <a href="#!/api/Ext.data.StoreManager-method-lookup" rel="Ext.data.StoreManager-method-lookup" class="docClass">lookup</a> method is aliased to <a href="#!/api/Ext-method-getStore" rel="Ext-method-getStore" class="docClass">Ext.getStore</a> for convenience.</p>
 *
 * <p>If a store is registered with the StoreManager, you can also refer to the store by it's identifier when registering
 * it with any Component that consumes data from a store:</p>
 *
 * <pre><code><a href="#!/api/Ext-method-create" rel="Ext-method-create" class="docClass">Ext.create</a>('<a href="#!/api/Ext.data.Store" rel="Ext.data.Store" class="docClass">Ext.data.Store</a>', {
 *     model: 'SomeModel',
 *     storeId: 'myStore'
 * });
 *
 * <a href="#!/api/Ext-method-create" rel="Ext-method-create" class="docClass">Ext.create</a>('<a href="#!/api/Ext.view.View" rel="Ext.view.View" class="docClass">Ext.view.View</a>', {
 *     store: 'myStore',
 *     // other configuration here
 * });
 * </code></pre>
 */
public const StoreManager:ext.data.SStoreManager;
}