package ext.data.events {
import ext.data.NodeInterface;
import net.jangaroo.ext.FlExtEvent;

[Uses("net.jangaroo.ext.FlExtEvent")]
public class TreeStore_node_isMove_contextEvent extends net.jangaroo.ext.FlExtEvent {
  public static const __PARAMETER_SEQUENCE__:Array;

  /**
   * "Fires when a child node is removed
   * @see ext.data.TreeStore
   * @eventType onNodeRemove
   */
  public static const NODE_REMOVE:String = "onNodeRemove";

  public function TreeStore_node_isMove_contextEvent(type:String, arguments:Array) {
    super(null, null);
  }

  /**
   * This node
   */
  public native function get source():ext.data.NodeInterface;

  /**
   * The removed node
   */
  public native function get node():ext.data.NodeInterface;

  /**
   * <code>true</code> if the child node is being removed so it can be moved to another position in the tree.
   */
  public native function get isMove():Boolean;

  /**
   * An object providing information about where the removed node came from. It contains the following properties:
   * <ul>
   *   <li><code>parentNode</code> : ext.data.NodeInterface
   * The node from which the removed node was removed.
   *   </li>
   *   <li><code>previousSibling</code> : ext.data.NodeInterface
   * The removed node's former previous sibling.
   *   </li>
   *   <li><code>nextSibling</code> : ext.data.NodeInterface
   * The removed node's former next sibling.
   * (a side effect of calling <a href="#!/api/Ext.data.NodeInterface-method-appendChild" rel="Ext.data.NodeInterface-method-appendChild" class="docClass">appendChild</a> or
   * <a href="#!/api/Ext.data.NodeInterface-method-insertBefore" rel="Ext.data.NodeInterface-method-insertBefore" class="docClass">insertBefore</a> with a node that already has a parentNode)
   *   </li>
   * </ul>
   */
  public native function get context():Object;
}
}