package ext.data.proxy {

[Uses("ext.data.proxy.DataProxy")]
[Uses("ext.mixin.Observable")]
[Uses("ext.Base")]
[Uses("ext.mixin.Factoryable")]
[Native("Ext.data.proxy.Client", require)]
[ExcludeClass]
/**
 * Base class for any client-side storage. Used as a superclass for <a href="#!/api/Ext.data.proxy.Memory" rel="Ext.data.proxy.Memory" class="docClass">Memory</a> and
 * <a href="#!/api/Ext.data.proxy.WebStorage" rel="Ext.data.proxy.WebStorage" class="docClass">Web Storage</a> proxies. Do not use directly, use one of the subclasses instead.
 */
public class ClientProxy extends ext.data.proxy.DataProxy {
  /**
   * @inheritDoc
   */
  public function ClientProxy(config:ext.data.proxy.DataProxy = null) {
    super();
  }

  /**
   * <code>true</code> in this class to identify that requests made on this proxy are
   * performed synchronously
   * @default true
   */
  override public native function get isSynchronous():Boolean;

  /**
   * @private
   */
  override public native function set isSynchronous(value:Boolean):void;

  /**
   * Abstract function that must be implemented by each ClientProxy subclass. This should purge all record data
   * from the client side storage, as well as removing any supporting data (such as lists of record IDs)
   */
  public native function clear():void;
}
}