package ext.data.validator {

[Uses("ext.data.validator.FormatValidator")]
[Uses("ext.data.validator.Validator")]
[Uses("ext.mixin.Factoryable")]
[Uses("ext.Base")]
[Native("Ext.data.validator.Email", require)]
/**
 * Validates that the value is a valid email.
 */
public class EmailValidator extends ext.data.validator.FormatValidator {
  /**
   * @param config @inheritDoc
   */
  public function EmailValidator(config:ext.data.validator.EmailValidator = null) {
    super();
  }

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * A matcher to check for simple emails. This may be overridden.
   * @default /^(")?(?:[^\."])(?:(?:[\.])?(?:[\w\-!#$%&'*+\/=?\^_`{|}~]))*\1&#64;(\w[\-\w]*\.){1,5}([A-Za-z]){2,6}$/
   * @see #getMatcher()
   * @see #setMatcher()
   */
  override public native function get matcher():RegExp;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  override public native function set matcher(value:RegExp):void;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * The error message to return when the value is not a valid email
   * @default 'Is not a valid email address'
   * @see #getMessage()
   * @see #setMessage()
   */
  override public native function get message():String;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  override public native function set message(value:String):void;
}
}