package ext.data.validator {

[Uses("ext.data.validator.ListValidator")]
[Uses("ext.data.validator.Validator")]
[Uses("ext.mixin.Factoryable")]
[Uses("ext.Base")]
[Native("Ext.data.validator.Exclusion", require)]
/**
 * Validates that the value does not exist in a <a href="#!/api/Ext.data.validator.Exclusion-cfg-list" rel="Ext.data.validator.Exclusion-cfg-list" class="docClass">list</a> of values.
 */
public class ExclusionValidator extends ext.data.validator.ListValidator {
  /**
   * @param config @inheritDoc
   */
  public function ExclusionValidator(config:ext.data.validator.ExclusionValidator = null) {
    super();
  }

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * The error message to return when the passed value exists in the
   * specified <a href="#!/api/Ext.data.validator.Exclusion-cfg-list" rel="Ext.data.validator.Exclusion-cfg-list" class="docClass">list</a>.
   * @default 'Is a value that has been excluded'
   * @see #getMessage()
   * @see #setMessage()
   */
  public native function get message():String;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set message(value:String):void;

  /**
   * Returns the value of <a href="#!/api/Ext.data.validator.Exclusion-cfg-message" rel="Ext.data.validator.Exclusion-cfg-message" class="docClass">message</a>.
   */
  public native function getMessage():String;

  /**
   * Sets the value of <a href="#!/api/Ext.data.validator.Exclusion-cfg-message" rel="Ext.data.validator.Exclusion-cfg-message" class="docClass">message</a>.
   * @param message The new value.
   */
  public native function setMessage(message:String):void;
}
}