package ext.data.validator {

[Uses("ext.data.validator.Validator")]
[Uses("ext.mixin.Factoryable")]
[Uses("ext.Base")]
[Native("Ext.data.validator.List", require)]
[ExcludeClass]
/**
 * A superclass for inclusion/exclusion validators.
 */
public class ListValidator extends ext.data.validator.Validator {
  /**
   * @param config @inheritDoc
   */
  public function ListValidator(config:ext.data.validator.ListValidator = null) {
    super();
  }

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * The list to check the passed value against.
   * @see #getList()
   * @see #setList()
   */
  public native function get list():Array;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set list(value:Array):void;

  /**
   * Returns the value of <a href="#!/api/Ext.data.validator.List-cfg-list" rel="Ext.data.validator.List-cfg-list" class="docClass">list</a>.
   */
  public native function getList():Array;

  /**
   * Sets the value of <a href="#!/api/Ext.data.validator.List-cfg-list" rel="Ext.data.validator.List-cfg-list" class="docClass">list</a>.
   * @param list The new value.
   */
  public native function setList(list:Array):void;
}
}