package ext.data.validator {

[Uses("ext.data.validator.BoundValidator")]
[Uses("ext.data.validator.Validator")]
[Uses("ext.mixin.Factoryable")]
[Uses("ext.Base")]
[Native("Ext.data.validator.Range", require)]
/**
 * Validates that the the value is between a <a href="#!/api/Ext.data.validator.Range-cfg-min" rel="Ext.data.validator.Range-cfg-min" class="docClass">min</a> and <a href="#!/api/Ext.data.validator.Range-cfg-max" rel="Ext.data.validator.Range-cfg-max" class="docClass">max</a>.
 */
public class RangeValidator extends ext.data.validator.BoundValidator {
  /**
   * @param config @inheritDoc
   */
  public function RangeValidator(config:ext.data.validator.RangeValidator = null) {
    super();
  }

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * The maximum value.
   * @see #getMax()
   * @see #setMax()
   */
  override public native function get max():Number;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  override public native function set max(value:Number):void;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * The minimum value.
   * @see #getMin()
   * @see #setMin()
   */
  override public native function get min():Number;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  override public native function set min(value:Number):void;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * The error message to return when the value is not numeric.
   * @default 'Must be numeric'
   * @see #getNanMessage()
   * @see #setNanMessage()
   */
  public native function get nanMessage():String;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set nanMessage(value:String):void;

  /**
   * Returns the value of <a href="#!/api/Ext.data.validator.Range-cfg-bothMessage" rel="Ext.data.validator.Range-cfg-bothMessage" class="docClass">bothMessage</a>.
   */
  public native function getBothMessage():String;

  /**
   * Returns the value of <a href="#!/api/Ext.data.validator.Range-cfg-nanMessage" rel="Ext.data.validator.Range-cfg-nanMessage" class="docClass">nanMessage</a>.
   */
  public native function getNanMessage():String;

  /**
   * Sets the value of <a href="#!/api/Ext.data.validator.Range-cfg-bothMessage" rel="Ext.data.validator.Range-cfg-bothMessage" class="docClass">bothMessage</a>.
   * @param bothMessage The new value.
   */
  public native function setBothMessage(bothMessage:String):void;

  /**
   * Sets the value of <a href="#!/api/Ext.data.validator.Range-cfg-nanMessage" rel="Ext.data.validator.Range-cfg-nanMessage" class="docClass">nanMessage</a>.
   * @param nanMessage The new value.
   */
  public native function setNanMessage(nanMessage:String):void;
}
}