package ext.data.validator {
import ext.Base;
import ext.data.Model;
import ext.mixin.IFactoryable;

[Uses("ext.Base")]
[Uses("ext.mixin.Factoryable")]
[Native("Ext.data.validator.Validator", require)]
/**
 * The base class for validators to be used to validate <a href="#!/api/Ext.data.field.Field" rel="Ext.data.field.Field" class="docClass">fields</a> in
 * a <a href="#!/api/Ext.data.Model" rel="Ext.data.Model" class="docClass">model</a>.
 *
 * <p>The model will call the <a href="#!/api/Ext.data.validator.Validator-method-validate" rel="Ext.data.validator.Validator-method-validate" class="docClass">validate</a> method, which may be overridden by subclasses.</p>
 */
public class Validator extends ext.Base implements ext.mixin.IFactoryable {
  /**
   * Creates new Validator.
   * @param config A config object. A function may also be passed,
   * which will be used as the <a href="#!/api/Ext.data.validator.Validator-method-validate" rel="Ext.data.validator.Validator-method-validate" class="docClass">validate</a> method for this validator.
   */
  public function Validator(config:ext.data.validator.Validator = null) {
    super();
  }

  /**
   * If this property is specified by the target class of this mixin its properties are
   * used to configure the created <code><a href="#!/api/Ext.Factory" rel="Ext.Factory" class="docClass">Ext.Factory</a></code>.
   */
  public native function get factoryConfig():Object;

  /**
   * @private
   */
  public native function set factoryConfig(value:Object):void;

  /**
   * A string representation of this format.
   * @default 'base'
   */
  public native function get type():String;

  /**
   * @private
   */
  public native function set type(value:String):void;

  /**
   * Validates the passed value.
   * @param value The value
   * @param record The record
   * @return <code>true</code> if the value is valid. A string may be returned if the value
   * is not valid, to indicate an error message. Any other non <code>true</code> value indicates the value
   * is not valid.
   */
  public native function validate(value:Object, record:ext.data.Model):*;
}
}