package ext.dd {
import js.HTMLElement;

[Native("Ext.dd.DragDropElement", require)]
public class DragDropElement {
  /**
   * Returns the X position of an html element
   * @param el the element for which to get the position
   * @return the X coordinate
   */
  public native function getPosX(el:js.HTMLElement):Number;

  /**
   * Returns the Y position of an html element
   * @param el the element for which to get the position
   * @return the Y coordinate
   */
  public native function getPosY(el:js.HTMLElement):Number;

  /**
   * Gets the scrollLeft
   * @return the document's scrollTop
   */
  public native function getScrollLeft():Number;

  /**
   * Gets the scrollTop
   * @return the document's scrollTop
   */
  public native function getScrollTop():Number;

  /**
   * Returns the specified element style property
   * @param el the element
   * @param styleProp the style property
   * @return The value of the style property
   */
  public native function getStyle(el:js.HTMLElement, styleProp:String):String;

  /**
   * Recursively searches the immediate parent and all child nodes for
   * the handle element in order to determine wheter or not it was
   * clicked.
   * @param node the html element to inspect
   */
  public native function handleWasClicked(node:js.HTMLElement):void;

  /**
   * Sets the x/y position of an element to the location of the
   * target element.
   * @param moveEl The element to move
   * @param targetEl The position reference element
   */
  public native function moveToEl(moveEl:js.HTMLElement, targetEl:js.HTMLElement):void;

  /**
   * Numeric array sort function
   * @return positive, negative or 0
   */
  public native function numericSort(a:Number, b:Number):Number;

  /**
   * Swap two nodes.  In IE, we use the native method, for others we
   * emulate the IE behavior
   * @param n1 the first node to swap
   * @param n2 the other node to swap
   */
  public native function swapNode(n1:js.HTMLElement, n2:js.HTMLElement):void;
}
}