package ext.dd {

[Uses("ext.dd.SScrollManager")]
[Uses("ext.Base")]
[Native("Ext.dd.ScrollManager", require)]
/**
 * Provides automatic scrolling of overflow regions in the page during drag operations.
 *
 * <p>The ScrollManager configs will be used as the defaults for any scroll container registered with it, but you can also
 * override most of the configs per scroll container by adding a ddScrollConfig object to the target element that
 * contains these properties: <a href="#!/api/Ext.dd.ScrollManager-property-hthresh" rel="Ext.dd.ScrollManager-property-hthresh" class="docClass">hthresh</a>, <a href="#!/api/Ext.dd.ScrollManager-property-vthresh" rel="Ext.dd.ScrollManager-property-vthresh" class="docClass">vthresh</a>, <a href="#!/api/Ext.dd.ScrollManager-property-increment" rel="Ext.dd.ScrollManager-property-increment" class="docClass">increment</a> and <a href="#!/api/Ext.dd.ScrollManager-property-frequency" rel="Ext.dd.ScrollManager-property-frequency" class="docClass">frequency</a>. Example
 * usage:</p>
 *
 * <pre><code>var el = <a href="#!/api/Ext-method-get" rel="Ext-method-get" class="docClass">Ext.get</a>('scroll-ct');
 * el.ddScrollConfig = {
 *     vthresh: 50,
 *     hthresh: -1,
 *     frequency: 100,
 *     increment: 200
 * };
 * <a href="#!/api/Ext.dd.ScrollManager-method-register" rel="Ext.dd.ScrollManager-method-register" class="docClass">Ext.dd.ScrollManager.register</a>(el);
 * </code></pre>
 *
 * <p>Note: This class is designed to be used in "Point Mode</p>
 */
public const ScrollManager:ext.dd.SScrollManager;
}