package ext.direct {
import ext.Base;

[Uses("ext.Base")]
[Native("Ext.direct.Event", require)]
/**
 * Base class for all Ext Direct events. An event is
 * created after some kind of interaction with the server.
 * The event class is essentially just a data structure
 * to hold a Direct response.
 */
public class DirectEvent extends ext.Base {
  /**
   * Creates new Event.
   * @param config Config object.
   */
  public function DirectEvent(config:ext.direct.DirectEvent = null) {
    super();
  }

  /**
   * Return the raw data for this event.
   * @return The data from the event
   */
  public native function getData():*;

  /**
   * Return the name for this event.
   * @return The name of event
   */
  public native function getName():String;
}
}