package ext.direct {

[Uses("ext.direct.Provider")]
[Uses("ext.mixin.Observable")]
[Uses("ext.Base")]
[Native("Ext.direct.JsonProvider", require)]
/**
 * A base provider for communicating using JSON. This is an abstract class
 * and should not be instanced directly.
 */
public class JsonProvider extends ext.direct.Provider {
  /**
   * @param config @inheritDoc
   */
  public function JsonProvider(config:ext.direct.JsonProvider = null) {
    super();
  }

  /**
   * Create an event from a response object
   * @param response Response object
   * @return The event
   */
  public native function createEvent(response:Object):ext.direct.DirectEvent;

  /**
   * Creates a set of events based on the XHR response
   * @param response The XHR response
   * @return An array of <a href="#!/api/Ext.direct.Event" rel="Ext.direct.Event" class="docClass">Ext.direct.Event</a>
   */
  public native function createEvents(response:Object):Array;
}
}