package ext.dom {

[Uses("ext.dom.Element")]
[Uses("ext.mixin.Observable")]
[Uses("ext.Base")]
[Uses("ext.util.Positionable")]
[Native("Ext.dom.Fly", require)]
/**
 * A flyweight <a href="#!/api/Ext.dom.Element" rel="Ext.dom.Element" class="docClass">Ext.dom.Element</a> that can be dynamically attached to a DOM node.
 * In general this class should not be instantiated directly.  Use <a href="#!/api/Ext-method-fly" rel="Ext-method-fly" class="docClass">Ext.fly</a>
 * to create and retrieve Fly instances.
 */
public class Fly extends ext.dom.Element {
  /**
   * @inheritDoc
   */
  public function Fly(idOrHtmlElement:Object) {
    super(null);
  }

  /**
   * This is <code>true</code> to identify Element flyweights
   * @default true
   */
  public native function get isFly():Boolean;

  /**
   * @private
   */
  public native function set isFly(value:Boolean):void;
}
}