package ext.dom.events {
import ext.dom.Element;
import net.jangaroo.ext.FlExtEvent;

[Uses("net.jangaroo.ext.FlExtEvent")]
public class ElementEvent extends net.jangaroo.ext.FlExtEvent {
  public static const __PARAMETER_SEQUENCE__:Array;

  /**
   * "Fires whenever this Element actually becomes visible (painted) on the screen. This is useful when you need to
   * perform 'read' operations on the DOM element, i.e: calculating natural sizes and positioning.
   *
   * <p><strong>Note:</strong> This event is not available to be used with event delegation. Instead <code>painted</code> only fires if you explicitly
   * add at least one listener to it, for performance reasons.</p>
   * @see ext.dom.Element
   * @eventType onPainted
   */
  public static const PAINTED:String = "onPainted";

  /**
   * "Important note: For the best performance on mobile devices, use this only when you absolutely need to monitor
   * a Element's size.
   *
   * <p><strong>Note:</strong> This event is not available to be used with event delegation. Instead <code>resize</code> only fires if you explicitly
   * add at least one listener to it, for performance reasons.</p>
   * @see ext.dom.Element
   * @eventType onResize
   */
  public static const RESIZE:String = "onResize";

  public function ElementEvent(type:String, arguments:Array) {
    super(null, null);
  }

  /**
   * The component instance.
   */
  public native function get source():ext.dom.Element;
}
}