package ext.event.gesture {

[Uses("ext.event.gesture.SingleTouch")]
[Uses("ext.event.gesture.GestureRecognizer")]
[Uses("ext.mixin.Identifiable")]
[Uses("ext.Base")]
[Native("Ext.event.gesture.DoubleTap", require)]
/**
 * A simple event recognizer which knows when you double tap.
 */
public class DoubleTap extends ext.event.gesture.SingleTouch {
  /**
   * @param config @inheritDoc
   */
  public function DoubleTap(config:ext.event.gesture.DoubleTap = null) {
    super();
  }

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * The maximum distance a touch can move without canceling recognition
   * @default 8
   * @see #getMoveDistance()
   * @see #setMoveDistance()
   */
  public native function get moveDistance():Number;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set moveDistance(value:Number):void;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * The minimum distance the second tap can occur from the first tap and still
   * be considered a doubletap
   * @default 24
   * @see #getTapDistance()
   * @see #setTapDistance()
   */
  public native function get tapDistance():Number;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set tapDistance(value:Number):void;

  /**
   * Returns the value of <a href="#!/api/Ext.event.gesture.DoubleTap-cfg-moveDistance" rel="Ext.event.gesture.DoubleTap-cfg-moveDistance" class="docClass">moveDistance</a>.
   */
  public native function getMoveDistance():Number;

  /**
   * Returns the value of <a href="#!/api/Ext.event.gesture.DoubleTap-cfg-tapDistance" rel="Ext.event.gesture.DoubleTap-cfg-tapDistance" class="docClass">tapDistance</a>.
   */
  public native function getTapDistance():Number;

  /**
   * Sets the value of <a href="#!/api/Ext.event.gesture.DoubleTap-cfg-moveDistance" rel="Ext.event.gesture.DoubleTap-cfg-moveDistance" class="docClass">moveDistance</a>.
   * @param moveDistance The new value.
   */
  public native function setMoveDistance(moveDistance:Number):void;

  /**
   * Sets the value of <a href="#!/api/Ext.event.gesture.DoubleTap-cfg-tapDistance" rel="Ext.event.gesture.DoubleTap-cfg-tapDistance" class="docClass">tapDistance</a>.
   * @param tapDistance The new value.
   */
  public native function setTapDistance(tapDistance:Number):void;
}
}