package ext.event.gesture {

[Uses("ext.event.gesture.SingleTouch")]
[Uses("ext.event.gesture.GestureRecognizer")]
[Uses("ext.mixin.Identifiable")]
[Uses("ext.Base")]
[Native("Ext.event.gesture.Tap", require)]
/**
 * A simple event recogniser which knows when you tap.
 */
public class Tap extends ext.event.gesture.SingleTouch {
  /**
   * @param config @inheritDoc
   */
  public function Tap(config:ext.event.gesture.Tap = null) {
    super();
  }

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * The maximimum distance in pixels a touchstart event can travel and still be considered a tap event.
   * @default 8
   * @see #getMoveDistance()
   * @see #setMoveDistance()
   */
  public native function get moveDistance():Number;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set moveDistance(value:Number):void;

  /**
   * Returns the value of <a href="#!/api/Ext.event.gesture.Tap-cfg-moveDistance" rel="Ext.event.gesture.Tap-cfg-moveDistance" class="docClass">moveDistance</a>.
   */
  public native function getMoveDistance():Number;

  /**
   * Sets the value of <a href="#!/api/Ext.event.gesture.Tap-cfg-moveDistance" rel="Ext.event.gesture.Tap-cfg-moveDistance" class="docClass">moveDistance</a>.
   * @param moveDistance The new value.
   */
  public native function setMoveDistance(moveDistance:Number):void;
}
}