package ext.events {
import ext.state.Stateful;
import net.jangaroo.ext.FlExtEvent;

[Uses("net.jangaroo.ext.FlExtEvent")]
public class Component_stateEvent extends net.jangaroo.ext.FlExtEvent {
  public static const __PARAMETER_SEQUENCE__:Array;

  /**
   * "Fires before the state of the object is restored. Return false from an event handler to stop the restore.
   * @see ext.Component
   * @eventType onBeforeStateRestore
   */
  public static const BEFORE_STATE_RESTORE:String = "onBeforeStateRestore";

  /**
   * "Fires before the state of the object is saved to the configured state provider. Return false to stop the save.
   * @see ext.Component
   * @eventType onBeforeStateSave
   */
  public static const BEFORE_STATE_SAVE:String = "onBeforeStateSave";

  /**
   * "Fires after the state of the object is restored.
   * @see ext.Component
   * @eventType onStateRestore
   */
  public static const STATE_RESTORE:String = "onStateRestore";

  /**
   * "Fires after the state of the object is saved to the configured state provider.
   * @see ext.Component
   * @eventType onStateSave
   */
  public static const STATE_SAVE:String = "onStateSave";

  public function Component_stateEvent(type:String, arguments:Array) {
    super(null, null);
  }

  public native function get source():ext.state.Stateful;

  /**
   * The hash of state values returned from the StateProvider. If this
   * event is not vetoed, then the state object is passed to <em><code>applyState</code></em>. By default,
   * that simply copies property values into this object. The method maybe overriden to
   * provide custom state restoration.
   */
  public native function get state():Object;
}
}