package ext.form.action {

[Uses("ext.form.action.SubmitAction")]
[Uses("ext.form.action.Action")]
[Uses("ext.Base")]
[Native("Ext.form.action.StandardSubmit", require)]
/**
 * A class which handles submission of data from <a href="#!/api/Ext.form.Basic" rel="Ext.form.Basic" class="docClass">Form</a>s using a standard <code>&lt;form&gt;</code> element submit.
 * It does not handle the response from the submit.
 *
 * <p>If validation of the form fields fails, the Form's afterAction method will be called. Otherwise, afterAction will not
 * be called.</p>
 *
 * <p>Instances of this class are only created by a <a href="#!/api/Ext.form.Basic" rel="Ext.form.Basic" class="docClass">Form</a> when
 * <a href="#!/api/Ext.form.Basic-method-submit" rel="Ext.form.Basic-method-submit" class="docClass">submit</a>ting, when the form's <a href="#!/api/Ext.form.Basic-cfg-standardSubmit" rel="Ext.form.Basic-cfg-standardSubmit" class="docClass">Ext.form.Basic.standardSubmit</a> config option is true.</p>
 */
public class StandardSubmitAction extends ext.form.action.SubmitAction {
  /**
   * @param config @inheritDoc
   */
  public function StandardSubmitAction(config:ext.form.action.StandardSubmitAction = null) {
    super();
  }

  [ExtConfig]
  /**
   * Optional target attribute to be used for the form when submitting.
   *
   * <p>Defaults to the current window/frame.</p>
   */
  public native function get target():String;

  [ExtConfig]
  /**
   * @private
   */
  public native function set target(value:String):void;
}
}