package ext.form.field.events {
import ext.event.Event;
import ext.form.field.BaseField;
import net.jangaroo.ext.FlExtEvent;

[Uses("net.jangaroo.ext.FlExtEvent")]
public class BaseField_eEvent extends net.jangaroo.ext.FlExtEvent {
  public static const __PARAMETER_SEQUENCE__:Array;

  /**
   * "Fires when any key related to navigation (arrows, tab, enter, esc, etc.) is pressed. To handle other keys
   * see <a href="#!/api/Ext.util.KeyMap" rel="Ext.util.KeyMap" class="docClass">Ext.util.KeyMap</a>. You can check <a href="#!/api/Ext.event.Event-method-getKey" rel="Ext.event.Event-method-getKey" class="docClass">Ext.event.Event.getKey</a> to determine which key was
   * pressed. For example:
   *
   * <pre><code>var form = new <a href="#!/api/Ext.form.Panel" rel="Ext.form.Panel" class="docClass">Ext.form.Panel</a>({
   *     ...
   *     items: [{
   *             fieldLabel: 'Field 1',
   *             name: 'field1',
   *             allowBlank: false
   *         },{
   *             fieldLabel: 'Field 2',
   *             name: 'field2',
   *             listeners: {
   *                 specialkey: function(field, e){
   *                     // e.HOME, e.END, e.PAGE_UP, e.PAGE_DOWN,
   *                     // e.TAB, e.ESC, arrow keys: e.LEFT, e.RIGHT, e.UP, e.DOWN
   *                     if (e.getKey() == e.ENTER) {
   *                         var form = field.up('form').getForm();
   *                         form.submit();
   *                     }
   *                 }
   *             }
   *         }
   *     ],
   *     ...
   * });
   * </code></pre>
   * @see ext.form.field.BaseField
   * @eventType onSpecialKey
   */
  public static const SPECIAL_KEY:String = "onSpecialKey";

  public function BaseField_eEvent(type:String, arguments:Array) {
    super(null, null);
  }

  public native function get source():ext.form.field.BaseField;

  /**
   * The event object
   */
  public native function get e():ext.event.Event;
}
}