package ext.form.field.events {
import net.jangaroo.ext.FlExtEvent;

[Uses("net.jangaroo.ext.FlExtEvent")]
public class ComboBox_queryPlanEvent extends net.jangaroo.ext.FlExtEvent {
  public static const __PARAMETER_SEQUENCE__:Array;

  /**
   * "Fires before all queries are processed. Return false to cancel the query or set the queryPlan's cancel
   * property to true.
   * @see ext.form.field.ComboBox
   * @eventType onBeforeQuery
   */
  public static const BEFORE_QUERY:String = "onBeforeQuery";

  public function ComboBox_queryPlanEvent(type:String, arguments:Array) {
    super(null, null);
  }

  /**
   * An object containing details about the query to be executed.
   * <ul>
   *   <li><code>combo</code> : ext.form.field.ComboBox
   * A reference to this ComboBox.
   *   </li>
   *   <li><code>query</code> : String
   * The query value to be used to match against the ComboBox's <a href="#!/api/Ext.form.field.ComboBox-cfg-valueField" rel="Ext.form.field.ComboBox-cfg-valueField" class="docClass">valueField</a>.
   *   </li>
   *   <li><code>forceAll</code> : Boolean
   * If <code>true</code>, causes the query to be executed even if the minChars threshold is not met.
   *   </li>
   *   <li><code>cancel</code> : Boolean
   * A boolean value which, if set to <code>true</code> upon return, causes the query not to be executed.
   *   </li>
   *   <li><code>rawQuery</code> : Boolean
   * If <code>true</code> indicates that the raw input field value is being used, and upon store load,
   *   </li>
   * </ul>
   */
  public native function get queryPlan():Object;
}
}