package ext.form.field.events {
import ext.form.field.SpinnerField;
import net.jangaroo.ext.FlExtEvent;

[Uses("net.jangaroo.ext.FlExtEvent")]
public class SpinnerFieldEvent extends net.jangaroo.ext.FlExtEvent {
  public static const __PARAMETER_SEQUENCE__:Array;

  /**
   * "Fires when the spinner is made to spin down.
   * @see ext.form.field.SpinnerField
   * @eventType onSpinDown
   */
  public static const SPIN_DOWN:String = "onSpinDown";

  /**
   * "Fires when a spin command has been finished. For example on mouseup
   * on the spin buttons, when an <code>UP</code> or <code>DOWN</code> arrow key is released
   * of when a mousewheel stops spinning.
   *
   * <p>When this event fires, the field's value has stabilized.</p>
   * @since 6.2.0
   * @see ext.form.field.SpinnerField
   * @eventType onSpinEnd
   */
  public static const SPIN_END:String = "onSpinEnd";

  /**
   * "Fires when the spinner is made to spin up.
   * @see ext.form.field.SpinnerField
   * @eventType onSpinUp
   */
  public static const SPIN_UP:String = "onSpinUp";

  public function SpinnerFieldEvent(type:String, arguments:Array) {
    super(null, null);
  }

  public native function get source():ext.form.field.SpinnerField;
}
}