package ext.form.field.events {
import ext.form.field.TextField;
import net.jangaroo.ext.FlExtEvent;

[Uses("net.jangaroo.ext.FlExtEvent")]
public class TextField_widthEvent extends net.jangaroo.ext.FlExtEvent {
  public static const __PARAMETER_SEQUENCE__:Array;

  /**
   * "Fires when the <strong><a href="#!/api/Ext.form.field.Text-method-autoSize" rel="Ext.form.field.Text-method-autoSize" class="docClass">autoSize</a></strong> function is triggered and the field is resized according to the
   * <a href="#!/api/Ext.form.field.Text-cfg-grow" rel="Ext.form.field.Text-cfg-grow" class="docClass">grow</a>/<a href="#!/api/Ext.form.field.Text-cfg-growMin" rel="Ext.form.field.Text-cfg-growMin" class="docClass">growMin</a>/<a href="#!/api/Ext.form.field.Text-cfg-growMax" rel="Ext.form.field.Text-cfg-growMax" class="docClass">growMax</a> configs as a result. This event provides a hook for the
   * developer to apply additional logic at runtime to resize the field if needed.
   * @see ext.form.field.TextField
   * @eventType onAutoSize
   */
  public static const AUTO_SIZE:String = "onAutoSize";

  public function TextField_widthEvent(type:String, arguments:Array) {
    super(null, null);
  }

  /**
   * This text field
   */
  public native function get source():ext.form.field.TextField;

  /**
   * The new field width
   */
  public native function get width():Number;
}
}