package ext.grid.plugin {
import ext.plugin.AbstractPlugin;

[Uses("ext.plugin.AbstractPlugin")]
[Uses("ext.Plugin")]
[Uses("ext.Base")]
[Native("Ext.grid.plugin.HeaderResizer", require)]
/**
 * Plugin to add header resizing functionality to a HeaderContainer.
 * Always resizing header to the left of the splitter you are resizing.
 */
public class GridHeaderResizerPlugin extends ext.plugin.AbstractPlugin {
  /**
   * @param config @inheritDoc
   */
  public function GridHeaderResizerPlugin(config:ext.grid.plugin.GridHeaderResizerPlugin = null) {
    super();
  }

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * True to resize on the fly rather than using a proxy marker.
   * @default false
   * @see #getDynamic()
   * @see #setDynamic()
   */
  public native function get dynamic():Boolean;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set dynamic(value:Boolean):void;

  /**
   * Returns the value of <a href="#!/api/Ext.grid.plugin.HeaderResizer-cfg-dynamic" rel="Ext.grid.plugin.HeaderResizer-cfg-dynamic" class="docClass">dynamic</a>.
   */
  public native function getDynamic():Boolean;

  /**
   * Sets the value of <a href="#!/api/Ext.grid.plugin.HeaderResizer-cfg-dynamic" rel="Ext.grid.plugin.HeaderResizer-cfg-dynamic" class="docClass">dynamic</a>.
   * @param dynamic The new value.
   */
  public native function setDynamic(dynamic:Boolean):void;
}
}