package ext.grid.property.events {
import net.jangaroo.ext.FlExtEvent;

[Uses("net.jangaroo.ext.FlExtEvent")]
public class PropertyGrid_source_recordId_value_oldValueEvent extends net.jangaroo.ext.FlExtEvent {
  public static const __PARAMETER_SEQUENCE__:Array;

  /**
   * "Fires before a property value changes.  Handlers can return false to cancel the property change
   * (this will internally call <a href="#!/api/Ext.data.Model-method-reject" rel="Ext.data.Model-method-reject" class="docClass">Ext.data.Model.reject</a> on the property's record).
   * @see ext.grid.property.PropertyGrid
   * @eventType onBeforePropertyChange
   */
  public static const BEFORE_PROPERTY_CHANGE:String = "onBeforePropertyChange";

  /**
   * "Fires after a property value has changed.
   * @see ext.grid.property.PropertyGrid
   * @eventType onPropertyChange
   */
  public static const PROPERTY_CHANGE:String = "onPropertyChange";

  public function PropertyGrid_source_recordId_value_oldValueEvent(type:String, arguments:Array) {
    super(null, null);
  }

  /**
   * The source data object for the grid (corresponds to the same object passed in
   * as the <a href="#!/api/Ext.grid.property.Grid-cfg-source" rel="Ext.grid.property.Grid-cfg-source" class="docClass">source</a> config property).
   */
  public native function get source():Object;

  /**
   * The record's id in the data store
   */
  public native function get recordId():String;

  /**
   * The current edited property value
   */
  public native function get value():Object;

  /**
   * The original property value prior to editing
   */
  public native function get oldValue():Object;
}
}