package ext.grid.selection {
import ext.grid.CellContext;

[Uses("ext.grid.selection.Selection")]
[Uses("ext.Base")]
[Native("Ext.grid.selection.Cells", require)]
/**
 * A class which encapsulates a range of cells defining a selection in a grid.
 *
 * <p>Note that when range start and end points are represented by an array, the
 * order is traditional <code>x, y</code> order, that is column index followed by row index.</p>
 */
public class CellsSelection extends ext.grid.selection.Selection {
  /**
   * This property indicates the this selection represents selected cells.
   * @default true
   */
  public native function get isCells():Boolean;

  /**
   * Returns <code>true</code> if the passed <a href="#!/api/Ext.grid.CellContext" rel="Ext.grid.CellContext" class="docClass">cell context</a> is selected.
   * @param cellContext The cell context to test.
   * @return <code>true</code> if the passed <a href="#!/api/Ext.grid.CellContext" rel="Ext.grid.CellContext" class="docClass">cell context</a> is selected.
   */
  public native function contains(cellContext:ext.grid.CellContext):Boolean;

  /**
   * @return The column index of the first column in the range or zero if no range.
   */
  public native function getFirstColumnIndex():Number;

  /**
   * @return The row index of the first row in the range or zero if no range.
   */
  public native function getFirstRowIndex():Number;

  /**
   * @return The column index of the last column in the range or -1 if no range.
   */
  public native function getLastColumnIndex():Number;

  /**
   * @return The row index of the last row in the range or -1 if no range.
   */
  public native function getLastRowIndex():Number;
}
}