package ext.layout {

[Native("Ext.layout.SizePolicy", require)]
/**
 * This class describes how a layout will interact with a component it manages.
 *
 * <p>There are special instances of this class stored as static properties to avoid object
 * instantiation. All instances of this class should be treated as readonly objects.</p>
 */
public class SizePolicy {
  /**
   * Indicates that the <code>height</code> of the component is consumed.
   */
  public native function get readsHeight():Boolean;

  /**
   * Indicates that the <code>width</code> of the component is consumed.
   */
  public native function get readsWidth():Boolean;

  /**
   * Indicates that the <code>height</code> of the component will be set (i.e., calculated).
   */
  public native function get setsHeight():Boolean;

  /**
   * Indicates that the <code>width</code> of the component will be set (i.e., calculated).
   */
  public native function get setsWidth():Boolean;
}
}