package ext.layout.container {

[Uses("ext.layout.container.ContainerLayout")]
[Uses("ext.layout.Layout")]
[Uses("ext.mixin.Factoryable")]
[Uses("ext.Base")]
[Uses("ext.util.ElementContainer")]
[Native("Ext.layout.container.CheckboxGroup", require)]
/**
 * This layout implements the column arrangement for <a href="#!/api/Ext.form.CheckboxGroup" rel="Ext.form.CheckboxGroup" class="docClass">Ext.form.CheckboxGroup</a> and <a href="#!/api/Ext.form.RadioGroup" rel="Ext.form.RadioGroup" class="docClass">Ext.form.RadioGroup</a>.
 * It groups the component's sub-items into columns based on the component's
 * <a href="#!/api/Ext.form.CheckboxGroup-cfg-columns" rel="Ext.form.CheckboxGroup-cfg-columns" class="docClass">columns</a> and <a href="#!/api/Ext.form.CheckboxGroup-cfg-vertical" rel="Ext.form.CheckboxGroup-cfg-vertical" class="docClass">Ext.form.CheckboxGroup.vertical</a> config properties.
 */
public class CheckboxGroupLayout extends ext.layout.container.ContainerLayout {
  /**
   * @param config @inheritDoc
   */
  public function CheckboxGroupLayout(config:ext.layout.container.CheckboxGroupLayout = null) {
    super();
  }

  [ExtConfig]
  /**
   * By default,  CheckboxGroup allocates all available space to the configured columns meaning that
   * column are evenly spaced across the container.
   *
   * <p>To have each column only be wide enough to fit the container Checkboxes (or Radios), set <code>autoFlex</code> to <code>false</code></p>
   * @default true
   */
  public native function get autoFlex():Boolean;

  [ExtConfig]
  /**
   * @private
   */
  public native function set autoFlex(value:Boolean):void;
}
}