package ext.menu {

[Uses("ext.menu.Menu")]
[Uses("ext.util.FocusableContainer")]
[Uses("ext.Mixin")]
[Uses("ext.Base")]
[Uses("ext.panel.Panel")]
[Uses("ext.container.DockingContainer")]
[Uses("ext.container.Container")]
[Uses("ext.mixin.Queryable")]
[Uses("ext.mixin.Container")]
[Uses("ext.Component")]
[Uses("ext.util.Positionable")]
[Uses("ext.util.Focusable")]
[Uses("ext.util.ElementContainer")]
[Uses("ext.mixin.Bindable")]
[Uses("ext.mixin.Observable")]
[Uses("ext.util.Animate")]
[Uses("ext.util.Floating")]
[Uses("ext.mixin.Inheritable")]
[Uses("ext.mixin.ComponentDelegation")]
[Uses("ext.mixin.Keyboard")]
[Uses("ext.util.Renderable")]
[Uses("ext.mixin.Accessible")]
[Uses("ext.state.Stateful")]
[Native("Ext.menu.Bar", require)]
/**
 * Horizontal Menu bar widget, a specialized version of the <a href="#!/api/Ext.menu.Menu" rel="Ext.menu.Menu" class="docClass">Ext.menu.Menu</a>.
 *
 * <pre class='inline-example '><code>new <a href="#!/api/Ext.menu.Bar" rel="Ext.menu.Bar" class="docClass">Ext.menu.Bar</a>({
 *      renderTo: <a href="#!/api/Ext-method-getBody" rel="Ext-method-getBody" class="docClass">Ext.getBody</a>(),
 *      width: 200,
 *      items: [{
 *          text: 'File',
 *          menu: [
 *              { text: 'Open...' },
 *              '-',
 *              { text: 'Close' }
 *          ]
 *      }, {
 *          text: 'Edit',
 *          menu: [
 *              { text: 'Cut' },
 *              { text: 'Copy' }
 *              { text: 'Paste' }
 *          ]
 *      }]
 *  });
 * </code></pre>
 */
public class MenuBar extends ext.menu.Menu {
  /**
   * @inheritDoc
   */
  public function MenuBar(config:ext.menu.Menu = null) {
    super();
  }

  /**
   * @config {String} defaultMenuAlign The default <a href="#!/api/Ext.menu.Item-cfg-menuAlign" rel="Ext.menu.Item-cfg-menuAlign" class="docClass">Ext.menu.Item.menuAlign</a> config
   * for direct child items of this Menu bar.
   * @default 'tl-bl?'
   */
  public native function get defaultMenuAlign():String;

  /**
   * @private
   */
  public native function set defaultMenuAlign(value:String):void;
}
}