package ext.menu {
import ext.Base;

[Uses("ext.Base")]
[Native]
/**
 * Provides a common registry groups of <a href="#!/api/Ext.menu.CheckItem" rel="Ext.menu.CheckItem" class="docClass">Ext.menu.CheckItem</a>s.
 *
 * <p>Since 5.1.0, this class no longer registers all menus in your applications.
 * To access all menus, use <a href="#!/api/Ext.ComponentQuery" rel="Ext.ComponentQuery" class="docClass">ComponentQuery</a>.</p>
 * <p>Type of singleton MenuManager.</p>
 * @see ext.menu.#MenuManager ext.menu.MenuManager
 */
public class SMenuManager extends ext.Base {
  /**
   * Returns a <a href="#!/api/Ext.menu.Menu" rel="Ext.menu.Menu" class="docClass">Ext.menu.Menu</a> object
   * @param menu The string menu id, an existing menu object reference, or a Menu config that will
   * be used to generate and return a new Menu this.
   * @param config A configuration to use when creating the menu.
   * @return The specified menu, or null if none are found
   */
  public native function get(menu:*, config:Object = null):ext.menu.Menu;

  /**
   * Hides all floating menus that are currently visible
   * @return success True if any active menus were hidden.
   */
  public native function hideAll():Boolean;
}
}