package ext.mixin {
import ext.Base;

[Uses("ext.Base")]
[Native("Ext.mixin.Mashup", require)]
/**
 * This mixin allows users to easily require external scripts in their classes. This load
 * process delays application launch (<code><a href="#!/api/Ext-method-onReady" rel="Ext-method-onReady" class="docClass">Ext.onReady</a></code>) until all such scripts are loaded
 * ensuring that your class will have access to its required scripts from the start.
 *
 * <p>For example:</p>
 *
 * <pre><code> <a href="#!/api/Ext-method-define" rel="Ext-method-define" class="docClass">Ext.define</a>('Feed', {
 *      mixins: '<a href="#!/api/Ext.mixin.Mashup" rel="Ext.mixin.Mashup" class="docClass">Ext.mixin.Mashup</a>',
 *
 *      requiredScripts: [
 *          'http://www.foo.com/code/bar.js'
 *      ],
 *
 *      // The code in "bar.js" will be available at application launch
 *  });
 * </code></pre>
 *
 * <p>&#64;cmd.optimizer.requires.async</p>
 */
public class Mashup extends ext.Base {}
}