package ext {

[Uses("ext.Sos")]
[Uses("ext.env.OS")]
[Native("Ext.os", require)]
/**
 * Provides useful information about the current operating system environment.
 *
 * <p>Example:</p>
 *
 * <pre><code>if (Ext.os.is.Windows) {
 *     // Windows specific code here
 * }
 *
 * if (Ext.os.is.iOS) {
 *     // iPad, iPod, iPhone, etc.
 * }
 *
 * console.log("Version " + <a href="#!/api/Ext.os-property-version" rel="Ext.os-property-version" class="docClass">Ext.os.version</a>);
 * </code></pre>
 *
 * <p>For a full list of supported values, refer to the <a href="#!/api/Ext.os-method-is" rel="Ext.os-method-is" class="docClass">is</a> property/method.</p>
 */
public const os:ext.Sos;
}