package ext.panel.events {
import ext.grid.selection.Selection;
import ext.panel.TablePanel;
import net.jangaroo.ext.FlExtEvent;

[Uses("net.jangaroo.ext.FlExtEvent")]
public class TablePanel_An_extensionEvent extends net.jangaroo.ext.FlExtEvent {
  public static const __PARAMETER_SEQUENCE__:Array;

  /**
   * ".
   * An event fired when an extension block is extended
   * using a drag gesture.  Only fired when the SpreadsheetSelectionModel is used and
   * configured with the
   * <a href="#!/api/Ext.grid.selection.SpreadsheetModel-cfg-extensible" rel="Ext.grid.selection.SpreadsheetModel-cfg-extensible" class="docClass">extensible</a> config.
   * @see ext.panel.TablePanel
   * @eventType onBeforeSelectionExtend
   */
  public static const BEFORE_SELECTION_EXTEND:String = "onBeforeSelectionExtend";

  /**
   * ".
   * An event fired when an extension block is dragged to
   * encompass a new range.  Only fired when the SpreadsheetSelectionModel is used and
   * configured with the
   * <a href="#!/api/Ext.grid.selection.SpreadsheetModel-cfg-extensible" rel="Ext.grid.selection.SpreadsheetModel-cfg-extensible" class="docClass">extensible</a> config.
   * @see ext.panel.TablePanel
   * @eventType onSelectionExtenderDrag
   */
  public static const SELECTION_EXTENDER_DRAG:String = "onSelectionExtenderDrag";

  public function TablePanel_An_extensionEvent(type:String, arguments:Array) {
    super(null, null);
  }

  /**
   * The owning grid.
   */
  public native function get grid():ext.panel.TablePanel;

  /**
   * object which encapsulates a contiguous selection block.
   */
  public native function get An():ext.grid.selection.Selection;

  /**
   * An object describing the type and size of extension.
   * <ul>
   *   <li><code>type</code> : String
   * <code>"rows"</code> or <code>"columns"</code>
   *   </li>
   *   <li><code>start</code> : ext.grid.CellContext
   * The start (top left) cell of the extension area.
   *   </li>
   *   <li><code>end</code> : ext.grid.CellContext
   * The end (bottom right) cell of the extension area.
   *   </li>
   *   <li><code>columns</code> : Number (optional)
   * The number of columns extended (-ve means on the left side).
   *   </li>
   *   <li><code>rows</code> : Number (optional)
   * The number of rows extended (-ve means on the top side).
   *   </li>
   * </ul>
   */
  public native function get extension():Object;
}
}