package ext.panel.events {
import ext.event.Event;
import ext.view.DataView;
import js.HTMLElement;
import net.jangaroo.ext.FlExtEvent;

[Uses("net.jangaroo.ext.FlExtEvent")]
public class TablePanel_view_rowBodyEl_eEvent extends net.jangaroo.ext.FlExtEvent {
  public static const __PARAMETER_SEQUENCE__:Array;

  /**
   * "Fires before the click event on a row body element is processed. Return false to
   * cancel the default action.
   *
   * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
   * used.</p>
   * @see ext.panel.TablePanel
   * @eventType onBeforeRowBodyClick
   */
  public static const BEFORE_ROW_BODY_CLICK:String = "onBeforeRowBodyClick";

  /**
   * "Fires before the contextmenu event on a row body element is processed. Return
   * false to cancel the default action.
   *
   * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
   * used.</p>
   * @see ext.panel.TablePanel
   * @eventType onBeforeRowBodyContextMenu
   */
  public static const BEFORE_ROW_BODY_CONTEXT_MENU:String = "onBeforeRowBodyContextMenu";

  /**
   * "Fires before the dblclick event on a row body element is processed. Return false
   * to cancel the default action.
   *
   * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
   * used.</p>
   * @see ext.panel.TablePanel
   * @eventType onBeforeRowBodyDblclick
   */
  public static const BEFORE_ROW_BODY_DBLCLICK:String = "onBeforeRowBodyDblclick";

  /**
   * "Fires before the keydown event on a row body element is processed. Return false
   * to cancel the default action.
   *
   * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
   * used.</p>
   * @see ext.panel.TablePanel
   * @eventType onBeforeRowBodyKeyDown
   */
  public static const BEFORE_ROW_BODY_KEY_DOWN:String = "onBeforeRowBodyKeyDown";

  /**
   * "Fires before the keypress event on a row body element is processed. Return false
   * to cancel the default action.
   *
   * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
   * used.</p>
   * @see ext.panel.TablePanel
   * @eventType onBeforeRowBodyKeypress
   */
  public static const BEFORE_ROW_BODY_KEYPRESS:String = "onBeforeRowBodyKeypress";

  /**
   * "Fires before the keyup event on a row body element is processed. Return false to
   * cancel the default action.
   *
   * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
   * used.</p>
   * @see ext.panel.TablePanel
   * @eventType onBeforeRowBodyKeyUp
   */
  public static const BEFORE_ROW_BODY_KEY_UP:String = "onBeforeRowBodyKeyUp";

  /**
   * "Fires before the longpress event on a row body element is processed. Return
   * false to cancel the default action.
   *
   * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
   * used.</p>
   * @see ext.panel.TablePanel
   * @eventType onBeforeRowBodyLongPress
   */
  public static const BEFORE_ROW_BODY_LONG_PRESS:String = "onBeforeRowBodyLongPress";

  /**
   * "Fires before the mousedown event on a row body element is processed. Return false
   * to cancel the default action.
   *
   * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
   * used.</p>
   * @see ext.panel.TablePanel
   * @eventType onBeforeRowBodyMouseDown
   */
  public static const BEFORE_ROW_BODY_MOUSE_DOWN:String = "onBeforeRowBodyMouseDown";

  /**
   * "Fires before the mouseup event on a row body element is processed. Return false
   * to cancel the default action.
   *
   * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
   * used.</p>
   * @see ext.panel.TablePanel
   * @eventType onBeforeRowBodyMouseUp
   */
  public static const BEFORE_ROW_BODY_MOUSE_UP:String = "onBeforeRowBodyMouseUp";

  /**
   * "Fires when a row body element is clicked
   *
   * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
   * used.</p>
   * @see ext.panel.TablePanel
   * @eventType onRowBodyClick
   */
  public static const ROW_BODY_CLICK:String = "onRowBodyClick";

  /**
   * "Fires when a row body element is right clicked
   *
   * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
   * used.</p>
   * @see ext.panel.TablePanel
   * @eventType onRowBodyContextMenu
   */
  public static const ROW_BODY_CONTEXT_MENU:String = "onRowBodyContextMenu";

  /**
   * "Fires when a row body element is double clicked
   *
   * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
   * used.</p>
   * @see ext.panel.TablePanel
   * @eventType onRowBodyDblclick
   */
  public static const ROW_BODY_DBLCLICK:String = "onRowBodyDblclick";

  /**
   * "Fires when a key is pressed down while a row body element is currently selected
   *
   * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
   * used.</p>
   * @see ext.panel.TablePanel
   * @eventType onRowBodyKeyDown
   */
  public static const ROW_BODY_KEY_DOWN:String = "onRowBodyKeyDown";

  /**
   * "Fires when a key is pressed while a row body element is currently selected.
   *
   * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
   * used.</p>
   * @see ext.panel.TablePanel
   * @eventType onRowBodyKeypress
   */
  public static const ROW_BODY_KEYPRESS:String = "onRowBodyKeypress";

  /**
   * "Fires when a key is released while a row body element is currently selected
   *
   * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
   * used.</p>
   * @see ext.panel.TablePanel
   * @eventType onRowBodyKeyUp
   */
  public static const ROW_BODY_KEY_UP:String = "onRowBodyKeyUp";

  /**
   * "Fires on a row body element longpress event
   *
   * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
   * used.</p>
   * @see ext.panel.TablePanel
   * @eventType onRowBodyLongPress
   */
  public static const ROW_BODY_LONG_PRESS:String = "onRowBodyLongPress";

  /**
   * "Fires when there is a mouse down on a row body element
   *
   * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
   * used.</p>
   * @see ext.panel.TablePanel
   * @eventType onRowBodyMouseDown
   */
  public static const ROW_BODY_MOUSE_DOWN:String = "onRowBodyMouseDown";

  /**
   * "Fires when there is a mouse up on a row body element
   *
   * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
   * used.</p>
   * @see ext.panel.TablePanel
   * @eventType onRowBodyMouseUp
   */
  public static const ROW_BODY_MOUSE_UP:String = "onRowBodyMouseUp";

  public function TablePanel_view_rowBodyEl_eEvent(type:String, arguments:Array) {
    super(null, null);
  }

  /**
   * The rowbody's owning View
   */
  public native function get view():ext.view.DataView;

  /**
   * The row body's element
   */
  public native function get rowBodyEl():js.HTMLElement;

  /**
   * The raw event object
   */
  public native function get e():ext.event.Event;
}
}