package ext.plugin {

[Uses("ext.plugin.AbstractPlugin")]
[Uses("ext.Plugin")]
[Uses("ext.Base")]
[Native("Ext.plugin.LazyItems", require)]
/**
 * This plugin defers the execution cost of the instantiation and initialization of child components of un-rendered items.
 *
 * <p>For example, in a <a href="#!/api/Ext.tab.Panel-cfg-deferredRender" rel="Ext.tab.Panel-cfg-deferredRender" class="docClass">deferredRender</a> <a href="#!/api/Ext.tab.Panel" rel="Ext.tab.Panel" class="docClass">TabPanel</a>, the un-rendered tabs
 * do not have to incur the cost of instantiating and initializing their descendant components until render.</p>
 *
 * <p>This plugin allows that.</p>
 *
 * <p>Add the items to the plugin:</p>
 *
 * <pre><code>{
 *     xtype: 'tabpanel',
 *     items: [{
 *         title: 'Tab One',
 *         plugins: {
 *             ptype: 'lazyitems',
 *             items: [... tab child items...]
 *         }
 *     }, {
 *         title: 'Tab One',
 *         plugins: {
 *             ptype: 'lazyitems',
 *             items: [... tab child items...]
 *         }
 *     }]
 * }
 * </code></pre>
 */
public class LazyItemsPlugin extends ext.plugin.AbstractPlugin {
  /**
   * @param config @inheritDoc
   */
  public function LazyItemsPlugin(config:ext.plugin.LazyItemsPlugin = null) {
    super();
  }
}
}