package ext.selection {

[Uses("ext.selection.SelectionModel")]
[Uses("ext.util.StoreHolder")]
[Uses("ext.Base")]
[Uses("ext.mixin.Observable")]
[Uses("ext.mixin.Factoryable")]
[Native("Ext.selection.DataViewModel", require)]
/**
 * Fired before a record is deselected. If any listener returns false, the
 * deselection is cancelled.
 * @eventType ext.selection.events.DataViewSelectionModel_record_indexEvent.BEFORE_DESELECT
 */
[Event(name = 'onBeforeDeselect', type = 'ext.selection.events.DataViewSelectionModel_record_indexEvent')]
/**
 * Fired before a record is selected. If any listener returns false, the
 * selection is cancelled.
 * @eventType ext.selection.events.DataViewSelectionModel_record_indexEvent.BEFORE_SELECT
 */
[Event(name = 'onBeforeSelect', type = 'ext.selection.events.DataViewSelectionModel_record_indexEvent')]
/**
 * Fired after a record is deselected
 * @eventType ext.selection.events.DataViewSelectionModel_recordEvent.DESELECT
 */
[Event(name = 'onDeselect', type = 'ext.selection.events.DataViewSelectionModel_recordEvent')]
/**
 * Fired after a record is selected
 * @eventType ext.selection.events.DataViewSelectionModel_record_indexEvent.SELECT
 */
[Event(name = 'onSelect', type = 'ext.selection.events.DataViewSelectionModel_record_indexEvent')]
/**
 * The DataViewModel selection model implements item-based selection for <a href="#!/api/Ext.view.View" rel="Ext.view.View" class="docClass">Ext.view.View</a>.
 * DataViewModel is the default dataview selection model and generally will not need to
 * be specified.
 */
public class DataViewSelectionModel extends ext.selection.SelectionModel {
  /**
   * @param config @inheritDoc
   */
  public function DataViewSelectionModel(config:ext.selection.DataViewSelectionModel = null) {
    super();
  }

  [Deprecated(replacement = "ext.view.NavigationModelView", since = "5.1.0")]
  [ExtConfig]
  /**
   * @default true
   */
  public native function get enableKeyNav():Boolean;

  [ExtConfig]
  /**
   * @private
   */
  public native function set enableKeyNav(value:Boolean):void;
}
}