package ext.sparkline {

[Uses("ext.sparkline.SparklineBase")]
[Uses("ext.Widget")]
[Uses("ext.mixin.ComponentDelegation")]
[Uses("ext.Mixin")]
[Uses("ext.Base")]
[Uses("ext.mixin.Bindable")]
[Uses("ext.mixin.Pluggable")]
[Uses("ext.mixin.Inheritable")]
[Uses("ext.Evented")]
[Uses("ext.mixin.Observable")]
[Native("Ext.sparkline.Pie", require)]
/**
 * Plots a pie chart based upon the input {<a href="#!/api/Ext.sparkline.Pie-cfg-values" rel="Ext.sparkline.Pie-cfg-values" class="docClass">values</a>} array.
 *
 * <p>See <a href="#!/api/Ext.sparkline.Base" rel="Ext.sparkline.Base" class="docClass">the base class</a> for a simple example.</p>
 */
public class SparklinePie extends ext.sparkline.SparklineBase {
  /**
   * @param config @inheritDoc
   */
  public function SparklinePie(config:ext.sparkline.SparklinePie = null) {
    super();
  }

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * Border color of line round slices.
   * @default #000
   * @see #getBorderColor()
   * @see #setBorderColor()
   */
  public native function get borderColor():String;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set borderColor(value:String):void;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * Border width in pixels of line round slices.
   * @default 0
   * @see #getBorderWidth()
   * @see #setBorderWidth()
   */
  public native function get borderWidth():Number;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set borderWidth(value:Number):void;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * Angle in degrees to offset the first slice.
   * @default 0
   * @see #getOffset()
   * @see #setOffset()
   */
  public native function get offset():Number;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set offset(value:Number):void;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * An array of CSS colro values to apply to the chart slices.
   * @default ['#3366cc', '#dc3912', '#ff9900', '#109618', '#66aa00', '#dd4477', '#0099c6', '#990099']
   * @see #getSliceColors()
   * @see #setSliceColors()
   */
  public native function get sliceColors():Array;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set sliceColors(value:Array):void;

  /**
   * Returns the value of <a href="#!/api/Ext.sparkline.Pie-cfg-borderColor" rel="Ext.sparkline.Pie-cfg-borderColor" class="docClass">borderColor</a>.
   */
  public native function getBorderColor():String;

  /**
   * Returns the value of <a href="#!/api/Ext.sparkline.Pie-cfg-borderWidth" rel="Ext.sparkline.Pie-cfg-borderWidth" class="docClass">borderWidth</a>.
   */
  public native function getBorderWidth():Number;

  /**
   * Returns the value of <a href="#!/api/Ext.sparkline.Pie-cfg-offset" rel="Ext.sparkline.Pie-cfg-offset" class="docClass">offset</a>.
   */
  public native function getOffset():Number;

  /**
   * Returns the value of <a href="#!/api/Ext.sparkline.Pie-cfg-sliceColors" rel="Ext.sparkline.Pie-cfg-sliceColors" class="docClass">sliceColors</a>.
   */
  public native function getSliceColors():Array;

  /**
   * Sets the value of <a href="#!/api/Ext.sparkline.Pie-cfg-borderColor" rel="Ext.sparkline.Pie-cfg-borderColor" class="docClass">borderColor</a>.
   * @param borderColor The new value.
   */
  public native function setBorderColor(borderColor:String):void;

  /**
   * Sets the value of <a href="#!/api/Ext.sparkline.Pie-cfg-borderWidth" rel="Ext.sparkline.Pie-cfg-borderWidth" class="docClass">borderWidth</a>.
   * @param borderWidth The new value.
   */
  public native function setBorderWidth(borderWidth:Number):void;

  /**
   * Sets the value of <a href="#!/api/Ext.sparkline.Pie-cfg-offset" rel="Ext.sparkline.Pie-cfg-offset" class="docClass">offset</a>.
   * @param offset The new value.
   */
  public native function setOffset(offset:Number):void;

  /**
   * Sets the value of <a href="#!/api/Ext.sparkline.Pie-cfg-sliceColors" rel="Ext.sparkline.Pie-cfg-sliceColors" class="docClass">sliceColors</a>.
   * @param sliceColors The new value.
   */
  public native function setSliceColors(sliceColors:Array):void;
}
}