package ext.toolbar {
import ext.Component;

[Uses("ext.Component")]
[Uses("ext.util.Positionable")]
[Uses("ext.Base")]
[Uses("ext.util.Focusable")]
[Uses("ext.util.ElementContainer")]
[Uses("ext.mixin.Bindable")]
[Uses("ext.mixin.Observable")]
[Uses("ext.util.Animate")]
[Uses("ext.util.Floating")]
[Uses("ext.mixin.Inheritable")]
[Uses("ext.Mixin")]
[Uses("ext.mixin.ComponentDelegation")]
[Uses("ext.mixin.Keyboard")]
[Uses("ext.util.Renderable")]
[Uses("ext.mixin.Accessible")]
[Uses("ext.state.Stateful")]
[Native("Ext.toolbar.Spacer", require)]
/**
 * A simple element that adds extra horizontal space between items in a toolbar.
 * By default a 2px wide space is added via CSS specification:
 *
 * <pre><code>.x-toolbar .x-toolbar-spacer {
 *     width: 2px;
 * }
 * </code></pre>
 *
 * <p>Example:</p>
 *
 * <pre class='inline-example '><code><a href="#!/api/Ext-method-create" rel="Ext-method-create" class="docClass">Ext.create</a>('<a href="#!/api/Ext.panel.Panel" rel="Ext.panel.Panel" class="docClass">Ext.panel.Panel</a>', {
 *     title: 'Toolbar Spacer Example',
 *     width: 300,
 *     height: 200,
 *     tbar : [
 *         'Item 1',
 *         { xtype: 'tbspacer' }, // or ' '
 *         'Item 2',
 *         // space width is also configurable via javascript
 *         { xtype: 'tbspacer', width: 50 }, // add a 50px space
 *         'Item 3'
 *     ],
 *     renderTo: <a href="#!/api/Ext-method-getBody" rel="Ext-method-getBody" class="docClass">Ext.getBody</a>()
 * });
 * </code></pre>
 */
public class Spacer extends ext.Component {
  /**
   * @param config @inheritDoc
   */
  public function Spacer(config:ext.toolbar.Spacer = null) {
    super();
  }
}
}