package ext.toolbar {

[Uses("ext.toolbar.Item")]
[Uses("ext.Component")]
[Uses("ext.util.Positionable")]
[Uses("ext.Base")]
[Uses("ext.util.Focusable")]
[Uses("ext.util.ElementContainer")]
[Uses("ext.mixin.Bindable")]
[Uses("ext.mixin.Observable")]
[Uses("ext.util.Animate")]
[Uses("ext.util.Floating")]
[Uses("ext.mixin.Inheritable")]
[Uses("ext.Mixin")]
[Uses("ext.mixin.ComponentDelegation")]
[Uses("ext.mixin.Keyboard")]
[Uses("ext.util.Renderable")]
[Uses("ext.mixin.Accessible")]
[Uses("ext.state.Stateful")]
[Native("Ext.toolbar.TextItem", require)]
/**
 * A simple class that renders text directly into a toolbar.
 *
 * <pre class='inline-example '><code><a href="#!/api/Ext-method-create" rel="Ext-method-create" class="docClass">Ext.create</a>('<a href="#!/api/Ext.panel.Panel" rel="Ext.panel.Panel" class="docClass">Ext.panel.Panel</a>', {
 *     title: 'Panel with TextItem',
 *     width: 300,
 *     height: 200,
 *     tbar: [
 *         { xtype: 'tbtext', html: 'Sample Text Item' }
 *     ],
 *     renderTo: <a href="#!/api/Ext-method-getBody" rel="Ext-method-getBody" class="docClass">Ext.getBody</a>()
 * });
 * </code></pre>
 */
public class TextItem extends ext.toolbar.Item {
  /**
   * @param config @inheritDoc
   */
  public function TextItem(config:ext.toolbar.TextItem = null) {
    super();
  }

  [Deprecated(replacement = "html", since = "5.1.0")]
  [ExtConfig]
  /**
   * The text to be used as innerHTML (html tags are accepted).
   * @default ''
   * @see #setText()
   */
  public native function get text():String;

  [ExtConfig]
  [Bindable(event = "DUMMY")]
  /**
   * @private
   */
  public native function set text(value:String):void;

  [Deprecated(replacement = "update", since = "5.1.0")]
  /**
   * Updates this item's text, setting the text to be used as innerHTML.
   * @param text The text to display (html accepted).
   */
  public native function setText(text:String):void;
}
}