package ext.view {
import ext.dom.Element;

[Uses("ext.view.NavigationModelView")]
[Uses("ext.util.StoreHolder")]
[Uses("ext.Base")]
[Uses("ext.mixin.Observable")]
[Uses("ext.mixin.Factoryable")]
[Native("Ext.view.BoundListKeyNav", require)]
/**
 * A specialized <a href="#!/api/Ext.util.KeyNav" rel="Ext.util.KeyNav" class="docClass">Ext.util.KeyNav</a> implementation for navigating a <a href="#!/api/Ext.view.BoundList" rel="Ext.view.BoundList" class="docClass">Ext.view.BoundList</a> using
 * the keyboard. The up, down, pageup, pagedown, home, and end keys move the active highlight
 * through the list. The enter key invokes the selection model's select action using the highlighted item.
 */
public class BoundListKeyNavView extends ext.view.NavigationModelView {
  /**
   * @param config @inheritDoc
   */
  public function BoundListKeyNavView(config:ext.view.BoundListKeyNavView = null) {
    super();
  }

  [ExtConfig]
  /**
   * The <a href="#!/api/Ext.view.BoundList" rel="Ext.view.BoundList" class="docClass">Ext.view.BoundList</a> instance for which key navigation will be managed.
   */
  public native function get boundList():ext.view.BoundListView;

  [ExtConfig]
  /**
   * @private
   */
  public native function set boundList(value:ext.view.BoundListView):void;

  /**
   * Highlights the item at the given index.
   */
  override protected native function focusItem(item:ext.dom.Element):void;

  /**
   * Triggers selection of the currently highlighted item according to the behavior of
   * the configured SelectionModel.
   */
  public native function selectHighlighted(e:Object):void;
}
}