package ext.view {
import ext.Component;
import ext.data.Model;
import ext.data.Store;
import ext.grid.column.Column;
import ext.grid.feature.Feature;
import ext.mixin.IQueryable;
import js.HTMLElement;

[Uses("ext.view.DataView")]
[Uses("ext.mixin.Queryable")]
[Uses("ext.view.AbstractView")]
[Uses("ext.util.StoreHolder")]
[Uses("ext.Base")]
[Uses("ext.Component")]
[Uses("ext.util.Positionable")]
[Uses("ext.util.Focusable")]
[Uses("ext.util.ElementContainer")]
[Uses("ext.mixin.Bindable")]
[Uses("ext.mixin.Observable")]
[Uses("ext.util.Animate")]
[Uses("ext.util.Floating")]
[Uses("ext.mixin.Inheritable")]
[Uses("ext.Mixin")]
[Uses("ext.mixin.ComponentDelegation")]
[Uses("ext.mixin.Keyboard")]
[Uses("ext.util.Renderable")]
[Uses("ext.mixin.Accessible")]
[Uses("ext.state.Stateful")]
[Native("Ext.view.Table", require)]
/**
 * Fired before the cell click is processed. Return false to cancel the default action.
 * @eventType ext.view.events.TableView_td_cellIndex_record_tr_rowIndex_eEvent.BEFORE_CELL_CLICK
 */
[Event(name = 'onBeforeCellClick', type = 'ext.view.events.TableView_td_cellIndex_record_tr_rowIndex_eEvent')]
/**
 * Fired before the cell right click is processed. Return false to cancel the default action.
 * @eventType ext.view.events.TableView_td_cellIndex_record_tr_rowIndex_eEvent.BEFORE_CELL_CONTEXT_MENU
 */
[Event(name = 'onBeforeCellContextMenu', type = 'ext.view.events.TableView_td_cellIndex_record_tr_rowIndex_eEvent')]
/**
 * Fired before the cell double click is processed. Return false to cancel the default action.
 * @eventType ext.view.events.TableView_td_cellIndex_record_tr_rowIndex_eEvent.BEFORE_CELL_DBLCLICK
 */
[Event(name = 'onBeforeCellDblclick', type = 'ext.view.events.TableView_td_cellIndex_record_tr_rowIndex_eEvent')]
/**
 * Fired before the cell key down is processed. Return false to cancel the default action.
 * @eventType ext.view.events.TableView_td_cellIndex_record_tr_rowIndex_eEvent.BEFORE_CELL_KEY_DOWN
 */
[Event(name = 'onBeforeCellKeyDown', type = 'ext.view.events.TableView_td_cellIndex_record_tr_rowIndex_eEvent')]
/**
 * Fired before the cell mouse down is processed. Return false to cancel the default action.
 * @eventType ext.view.events.TableView_td_cellIndex_record_tr_rowIndex_eEvent.BEFORE_CELL_MOUSE_DOWN
 */
[Event(name = 'onBeforeCellMouseDown', type = 'ext.view.events.TableView_td_cellIndex_record_tr_rowIndex_eEvent')]
/**
 * Fired before the cell mouse up is processed. Return false to cancel the default action.
 * @eventType ext.view.events.TableView_td_cellIndex_record_tr_rowIndex_eEvent.BEFORE_CELL_MOUSE_UP
 */
[Event(name = 'onBeforeCellMouseUp', type = 'ext.view.events.TableView_td_cellIndex_record_tr_rowIndex_eEvent')]
/**
 * Fires before the click event on a row body element is processed. Return false to
 * cancel the default action.
 *
 * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
 * used.</p>
 * @eventType ext.view.events.TableView_view_rowBodyEl_eEvent.BEFORE_ROW_BODY_CLICK
 */
[Event(name = 'onBeforeRowBodyClick', type = 'ext.view.events.TableView_view_rowBodyEl_eEvent')]
/**
 * Fires before the contextmenu event on a row body element is processed. Return
 * false to cancel the default action.
 *
 * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
 * used.</p>
 * @eventType ext.view.events.TableView_view_rowBodyEl_eEvent.BEFORE_ROW_BODY_CONTEXT_MENU
 */
[Event(name = 'onBeforeRowBodyContextMenu', type = 'ext.view.events.TableView_view_rowBodyEl_eEvent')]
/**
 * Fires before the dblclick event on a row body element is processed. Return false
 * to cancel the default action.
 *
 * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
 * used.</p>
 * @eventType ext.view.events.TableView_view_rowBodyEl_eEvent.BEFORE_ROW_BODY_DBLCLICK
 */
[Event(name = 'onBeforeRowBodyDblclick', type = 'ext.view.events.TableView_view_rowBodyEl_eEvent')]
/**
 * Fires before the keydown event on a row body element is processed. Return false
 * to cancel the default action.
 *
 * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
 * used.</p>
 * @eventType ext.view.events.TableView_view_rowBodyEl_eEvent.BEFORE_ROW_BODY_KEY_DOWN
 */
[Event(name = 'onBeforeRowBodyKeyDown', type = 'ext.view.events.TableView_view_rowBodyEl_eEvent')]
/**
 * Fires before the keypress event on a row body element is processed. Return false
 * to cancel the default action.
 *
 * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
 * used.</p>
 * @eventType ext.view.events.TableView_view_rowBodyEl_eEvent.BEFORE_ROW_BODY_KEYPRESS
 */
[Event(name = 'onBeforeRowBodyKeypress', type = 'ext.view.events.TableView_view_rowBodyEl_eEvent')]
/**
 * Fires before the keyup event on a row body element is processed. Return false to
 * cancel the default action.
 *
 * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
 * used.</p>
 * @eventType ext.view.events.TableView_view_rowBodyEl_eEvent.BEFORE_ROW_BODY_KEY_UP
 */
[Event(name = 'onBeforeRowBodyKeyUp', type = 'ext.view.events.TableView_view_rowBodyEl_eEvent')]
/**
 * Fires before the longpress event on a row body element is processed. Return
 * false to cancel the default action.
 *
 * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
 * used.</p>
 * @eventType ext.view.events.TableView_view_rowBodyEl_eEvent.BEFORE_ROW_BODY_LONG_PRESS
 */
[Event(name = 'onBeforeRowBodyLongPress', type = 'ext.view.events.TableView_view_rowBodyEl_eEvent')]
/**
 * Fires before the mousedown event on a row body element is processed. Return false
 * to cancel the default action.
 *
 * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
 * used.</p>
 * @eventType ext.view.events.TableView_view_rowBodyEl_eEvent.BEFORE_ROW_BODY_MOUSE_DOWN
 */
[Event(name = 'onBeforeRowBodyMouseDown', type = 'ext.view.events.TableView_view_rowBodyEl_eEvent')]
/**
 * Fires before the mouseup event on a row body element is processed. Return false
 * to cancel the default action.
 *
 * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
 * used.</p>
 * @eventType ext.view.events.TableView_view_rowBodyEl_eEvent.BEFORE_ROW_BODY_MOUSE_UP
 */
[Event(name = 'onBeforeRowBodyMouseUp', type = 'ext.view.events.TableView_view_rowBodyEl_eEvent')]
/**
 * Fired when View is asked to exit Actionable mode in the current row,
 * and proceed to the previous/next row. If the handler returns <code>false</code>,
 * View processing is aborted.
 * @eventType ext.view.events.TableView_keyEvent_prevRow_nextRow_forwardEvent.BEFORE_ROW_EXIT
 */
[Event(name = 'onBeforeRowExit', type = 'ext.view.events.TableView_keyEvent_prevRow_nextRow_forwardEvent')]
/**
 * Fired when table cell is clicked.
 * @eventType ext.view.events.TableView_td_cellIndex_record_tr_rowIndex_eEvent.CELL_CLICK
 */
[Event(name = 'onCellClick', type = 'ext.view.events.TableView_td_cellIndex_record_tr_rowIndex_eEvent')]
/**
 * Fired when table cell is right clicked.
 * @eventType ext.view.events.TableView_td_cellIndex_record_tr_rowIndex_eEvent.CELL_CONTEXT_MENU
 */
[Event(name = 'onCellContextMenu', type = 'ext.view.events.TableView_td_cellIndex_record_tr_rowIndex_eEvent')]
/**
 * Fired when table cell is double clicked.
 * @eventType ext.view.events.TableView_td_cellIndex_record_tr_rowIndex_eEvent.CELL_DBLCLICK
 */
[Event(name = 'onCellDblclick', type = 'ext.view.events.TableView_td_cellIndex_record_tr_rowIndex_eEvent')]
/**
 * Fired when the keydown event is captured on the cell.
 * @eventType ext.view.events.TableView_td_cellIndex_record_tr_rowIndex_eEvent.CELL_KEY_DOWN
 */
[Event(name = 'onCellKeyDown', type = 'ext.view.events.TableView_td_cellIndex_record_tr_rowIndex_eEvent')]
/**
 * Fired when the mousedown event is captured on the cell.
 * @eventType ext.view.events.TableView_td_cellIndex_record_tr_rowIndex_eEvent.CELL_MOUSE_DOWN
 */
[Event(name = 'onCellMouseDown', type = 'ext.view.events.TableView_td_cellIndex_record_tr_rowIndex_eEvent')]
/**
 * Fired when the mouseup event is captured on the cell.
 * @eventType ext.view.events.TableView_td_cellIndex_record_tr_rowIndex_eEvent.CELL_MOUSE_UP
 */
[Event(name = 'onCellMouseUp', type = 'ext.view.events.TableView_td_cellIndex_record_tr_rowIndex_eEvent')]
/**
 * Fires when a row body element is clicked
 *
 * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
 * used.</p>
 * @eventType ext.view.events.TableView_view_rowBodyEl_eEvent.ROW_BODY_CLICK
 */
[Event(name = 'onRowBodyClick', type = 'ext.view.events.TableView_view_rowBodyEl_eEvent')]
/**
 * Fires when a row body element is right clicked
 *
 * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
 * used.</p>
 * @eventType ext.view.events.TableView_view_rowBodyEl_eEvent.ROW_BODY_CONTEXT_MENU
 */
[Event(name = 'onRowBodyContextMenu', type = 'ext.view.events.TableView_view_rowBodyEl_eEvent')]
/**
 * Fires when a row body element is double clicked
 *
 * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
 * used.</p>
 * @eventType ext.view.events.TableView_view_rowBodyEl_eEvent.ROW_BODY_DBLCLICK
 */
[Event(name = 'onRowBodyDblclick', type = 'ext.view.events.TableView_view_rowBodyEl_eEvent')]
/**
 * Fires when a key is pressed down while a row body element is currently selected
 *
 * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
 * used.</p>
 * @eventType ext.view.events.TableView_view_rowBodyEl_eEvent.ROW_BODY_KEY_DOWN
 */
[Event(name = 'onRowBodyKeyDown', type = 'ext.view.events.TableView_view_rowBodyEl_eEvent')]
/**
 * Fires when a key is pressed while a row body element is currently selected.
 *
 * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
 * used.</p>
 * @eventType ext.view.events.TableView_view_rowBodyEl_eEvent.ROW_BODY_KEYPRESS
 */
[Event(name = 'onRowBodyKeypress', type = 'ext.view.events.TableView_view_rowBodyEl_eEvent')]
/**
 * Fires when a key is released while a row body element is currently selected
 *
 * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
 * used.</p>
 * @eventType ext.view.events.TableView_view_rowBodyEl_eEvent.ROW_BODY_KEY_UP
 */
[Event(name = 'onRowBodyKeyUp', type = 'ext.view.events.TableView_view_rowBodyEl_eEvent')]
/**
 * Fires on a row body element longpress event
 *
 * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
 * used.</p>
 * @eventType ext.view.events.TableView_view_rowBodyEl_eEvent.ROW_BODY_LONG_PRESS
 */
[Event(name = 'onRowBodyLongPress', type = 'ext.view.events.TableView_view_rowBodyEl_eEvent')]
/**
 * Fires when there is a mouse down on a row body element
 *
 * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
 * used.</p>
 * @eventType ext.view.events.TableView_view_rowBodyEl_eEvent.ROW_BODY_MOUSE_DOWN
 */
[Event(name = 'onRowBodyMouseDown', type = 'ext.view.events.TableView_view_rowBodyEl_eEvent')]
/**
 * Fires when there is a mouse up on a row body element
 *
 * <p><strong>Note:</strong> This event is fired only when the <a href="#!/api/Ext.grid.feature.RowBody" rel="Ext.grid.feature.RowBody" class="docClass">Ext.grid.feature.RowBody</a> feature is
 * used.</p>
 * @eventType ext.view.events.TableView_view_rowBodyEl_eEvent.ROW_BODY_MOUSE_UP
 */
[Event(name = 'onRowBodyMouseUp', type = 'ext.view.events.TableView_view_rowBodyEl_eEvent')]
/**
 * Fired when table cell is clicked.
 * @eventType ext.view.events.TableView_record_tr_rowIndex_eEvent.ROW_CLICK
 */
[Event(name = 'onRowClick', type = 'ext.view.events.TableView_record_tr_rowIndex_eEvent')]
/**
 * Fired when table cell is right clicked.
 * @eventType ext.view.events.TableView_record_tr_rowIndex_eEvent.ROW_CONTEXT_MENU
 */
[Event(name = 'onRowContextMenu', type = 'ext.view.events.TableView_record_tr_rowIndex_eEvent')]
/**
 * Fired when table cell is double clicked.
 * @eventType ext.view.events.TableView_record_tr_rowIndex_eEvent.ROW_DBLCLICK
 */
[Event(name = 'onRowDblclick', type = 'ext.view.events.TableView_record_tr_rowIndex_eEvent')]
/**
 * Fired when the keydown event is captured on the cell.
 * @eventType ext.view.events.TableView_record_tr_rowIndex_eEvent.ROW_KEY_DOWN
 */
[Event(name = 'onRowKeyDown', type = 'ext.view.events.TableView_record_tr_rowIndex_eEvent')]
/**
 * Fired when the mousedown event is captured on the cell.
 * @eventType ext.view.events.TableView_record_tr_rowIndex_eEvent.ROW_MOUSE_DOWN
 */
[Event(name = 'onRowMouseDown', type = 'ext.view.events.TableView_record_tr_rowIndex_eEvent')]
/**
 * Fired when the mouseup event is captured on the cell.
 * @eventType ext.view.events.TableView_record_tr_rowIndex_eEvent.ROW_MOUSE_UP
 */
[Event(name = 'onRowMouseUp', type = 'ext.view.events.TableView_record_tr_rowIndex_eEvent')]
/**
 * This class encapsulates the user interface for a tabular data set.
 * It acts as a centralized manager for controlling the various interface
 * elements of the view. This includes handling events, such as row and cell
 * level based DOM events. It also reacts to events from the underlying <a href="#!/api/Ext.selection.Model" rel="Ext.selection.Model" class="docClass">Ext.selection.Model</a>
 * to provide visual feedback to the user.
 *
 * <p>This class does not provide ways to manipulate the underlying data of the configured
 * <a href="#!/api/Ext.data.Store" rel="Ext.data.Store" class="docClass">Ext.data.Store</a>.</p>
 *
 * <p>This is the base class for both <a href="#!/api/Ext.view.Table" rel="Ext.view.Table" class="docClass">Ext.grid.View</a> and <a href="#!/api/Ext.tree.View" rel="Ext.tree.View" class="docClass">Ext.tree.View</a> and is not
 * to be used directly.</p>
 */
public class TableView extends ext.view.DataView implements ext.mixin.IQueryable {
  /**
   * @param config @inheritDoc
   */
  public function TableView(config:ext.view.TableView = null) {
    super();
  }

  /**
   * This value is <code>true</code> when the grid has been set to actionable mode by the user.
   *
   * <p>See http://www.w3.org/TR/2013/WD-wai-aria-practices-20130307/#grid</p>
   * @default false
   */
  public native function get actionableMode():Boolean;

  /**
   * <code>true</code> in this class to identify an object as an instantiated Ext.view.TableView, or subclass thereof.
   * @default true
   */
  public native function get isTableView():Boolean;

  /**
   * @private
   */
  public native function set isTableView(value:Boolean):void;

  [ExtConfig]
  /**
   * True to enable text selection inside this view.
   * @default false
   */
  public native function get enableTextSelection():Boolean;

  [ExtConfig]
  /**
   * @private
   */
  public native function set enableTextSelection(value:Boolean):void;

  [ExtConfig]
  /**
   * A CSS class to add to the <em>first</em> cell in every row to enable special styling for the first column.
   * If no styling is needed on the first column, this may be configured as <code>null</code>.
   * @default 'x-grid-cell-first'
   */
  public native function get firstCls():String;

  [ExtConfig]
  /**
   * @private
   */
  public native function set firstCls(value:String):void;

  [ExtConfig]
  /**
   * A CSS class to add to the <em>last</em> cell in every row to enable special styling for the last column.
   * If no styling is needed on the last column, this may be configured as <code>null</code>.
   * @default 'x-grid-cell-last'
   */
  public native function get lastCls():String;

  [ExtConfig]
  /**
   * @private
   */
  public native function set lastCls(value:String):void;

  [ExtConfig]
  /**
   * True to show the dirty cell indicator when a cell has been modified.
   * @default true
   */
  public native function get markDirty():Boolean;

  [ExtConfig]
  /**
   * @private
   */
  public native function set markDirty(value:Boolean):void;

  [ExtConfig]
  /**
   * True to stripe the rows.
   *
   * <p>This causes the CSS class <strong><code>x-grid-row-alt</code></strong> to be added to alternate rows of
   * the grid. A default CSS rule is provided which sets a background color, but you can override this
   * with a rule which either overrides the <strong>background-color</strong> style using the <code>!important</code>
   * modifier, or which uses a CSS selector of higher specificity.</p>
   * @default true
   */
  public native function get stripeRows():Boolean;

  [ExtConfig]
  /**
   * @private
   */
  public native function set stripeRows(value:Boolean):void;

  /**
   * Disable this view.
   *
   * <p>Disables interaction with, and masks this view.</p>
   *
   * <p>Note that the encapsulating <a href="#!/api/Ext.panel.Table" rel="Ext.panel.Table" class="docClass">Ext.panel.Table</a> panel is <em>not</em> disabled, and other <em>docked</em>
   * components such as the panel header, the column header container, and docked toolbars will still be enabled.
   * The panel itself can be disabled if that is required, or individual docked components could be disabled.</p>
   *
   * <p>See <a href="#!/api/Ext.panel.Table" rel="Ext.panel.Table" class="docClass">#disableColumnHeaders disableColumnHeaders</a> and <a href="#!/api/Ext.panel.Table" rel="Ext.panel.Table" class="docClass">#enableColumnHeaders enableColumnHeaders</a>.</p>
   * @since 1.1.0
   * @param silent Passing <code>true</code> will suppress the <code>disable</code> event from being fired.
   * @default false
   */
  override public native function disable(silent:Boolean = false):void;

  /**
   * Adds a CSS Class to a specific row.
   * @param rowInfo An HTMLElement, index or instance of a model
   * representing this row
   */
  public native function addRowCls(rowInfo:*, cls:String):void;

  /**
   * Retrieves the first direct child of this container which matches the passed selector or component.
   * The passed in selector must comply with an <a href="#!/api/Ext.ComponentQuery" rel="Ext.ComponentQuery" class="docClass">Ext.ComponentQuery</a> selector, or it can be an actual <a href="#!/api/Ext.Component" rel="Ext.Component" class="docClass">Ext.Component</a>.
   * @param selector An <a href="#!/api/Ext.ComponentQuery" rel="Ext.ComponentQuery" class="docClass">Ext.ComponentQuery</a> selector. If no selector is
   * specified, the first child will be returned.
   * @return The matching child <a href="#!/api/Ext.Component" rel="Ext.Component" class="docClass">Ext.Component</a> (or <code>null</code> if no match was found).
   */
  public native function child(selector:* = undefined):ext.Component;

  /**
   * Retrieves the first descendant of this container which matches the passed selector.
   * The passed in selector must comply with an <a href="#!/api/Ext.ComponentQuery" rel="Ext.ComponentQuery" class="docClass">Ext.ComponentQuery</a> selector, or it can be an actual <a href="#!/api/Ext.Component" rel="Ext.Component" class="docClass">Ext.Component</a>.
   * @param selector An <a href="#!/api/Ext.ComponentQuery" rel="Ext.ComponentQuery" class="docClass">Ext.ComponentQuery</a> selector or <a href="#!/api/Ext.Component" rel="Ext.Component" class="docClass">Ext.Component</a>. If no selector is
   * specified, the first child will be returned.
   * @return The matching descendant <a href="#!/api/Ext.Component" rel="Ext.Component" class="docClass">Ext.Component</a> (or <code>null</code> if no match was found).
   */
  public native function down(selector:* = undefined):ext.Component;

  /**
   * Focuses a particular row and brings it into view. Will fire the rowfocus event.
   * @param row An HTMLElement template node, index of a template node, the id of a template node or the
   * @param delay Delay the focus this number of milliseconds (true for 10 milliseconds).
   * record associated with the node.
   */
  public native function focusRow(row:*, delay:* = undefined):void;

  /**
   * Returns a CSS selector which selects the outermost element(s) in this view.
   */
  public native function getBodySelector():String;

  /**
   * Returns a CSS selector which selects a particular column if the desired header is passed,
   * or a general cell selector is no parameter is passed.
   * @param header The column for which to return the selector. If
   * omitted, the general cell selector which matches <strong>ant cell</strong> will be returned.
   */
  public native function getCellSelector(header:ext.grid.column.Column = null):String;

  /**
   * Returns a CSS selector which selects the element(s) which define the width of a column.
   *
   * <p>This is used by the <a href="#!/api/Ext.view.TableLayout" rel="Ext.view.TableLayout" class="docClass">Ext.view.TableLayout</a> when resizing columns.</p>
   */
  public native function getColumnSizerSelector(header:Object):String;

  /**
   * Get a reference to a feature
   * @param id The id of the feature
   * @return The feature. Undefined if not found
   */
  public native function getFeature(id:String):ext.grid.feature.Feature;

  /**
   * Returns a CSS selector which selects items of the view rendered by the outerRowTpl
   */
  public native function getItemSelector():String;

  /**
   * Returns the table row given the passed Record, or index or node.
   * @param nodeInfo The node or record, or row index.
   * to return the top level row.
   * @return The node or null if it wasn't found
   */
  public native function getRow(nodeInfo:*):js.HTMLElement;

  /**
   * Override this function to apply custom CSS classes to rows during rendering. This function should return the
   * CSS class name (or empty string '' for none) that will be added to the row's wrapping element. To apply multiple
   * class names, simply return them space-delimited within the string (e.g. 'my-class another-class').
   * Example usage:
   *
   * <pre><code>viewConfig: {
   *     getRowClass: function(record, rowIndex, rowParams, store){
   *         return record.get("valid") ? "row-valid" : "row-error";
   *     }
   * }
   * </code></pre>
   * @param record The record corresponding to the current row.
   * @param index The row index.
   * @param rowParams <strong>DEPRECATED.</strong> For row body use the
   * <a href="#!/api/Ext.grid.feature.RowBody-method-getAdditionalData" rel="Ext.grid.feature.RowBody-method-getAdditionalData" class="docClass">getAdditionalData</a> method of the rowbody feature.
   * @param store The store this grid is bound to
   * @return a CSS class name to add to the row.
   */
  public native function getRowClass(record:ext.data.Model, index:Number, rowParams:Object, store:ext.data.Store):String;

  /**
   * Retrieves all descendant components which match the passed selector.
   * Executes an <a href="#!/api/Ext.ComponentQuery-method-query" rel="Ext.ComponentQuery-method-query" class="docClass">Ext.ComponentQuery.query</a> using this container as its root.
   * @param selector Selector complying to an <a href="#!/api/Ext.ComponentQuery" rel="Ext.ComponentQuery" class="docClass">Ext.ComponentQuery</a> selector.
   * If no selector is specified all items will be returned.
   * @return Components which matched the selector
   */
  public native function query(selector:String = null):Array;

  /**
   * Retrieves all descendant components which match the passed function.
   * The function should return false for components that are to be
   * excluded from the selection.
   * @param fn The matcher function. It will be called with a single argument,
   * the component being tested.
   * @param scope The scope in which to run the function. If not specified,
   * it will default to the active component.
   * @return Components matched by the passed function
   */
  public native function queryBy(fn:Function, scope:Object = null):Array;

  /**
   * Finds a component at any level under this container matching the id/itemId.
   * This is a shorthand for calling ct.down('#' + id);
   * @param id The id to find
   * @return The matching id, null if not found
   */
  public native function queryById(id:String):ext.Component;

  /**
   * Removes a CSS Class from a specific row.
   * @param rowInfo An HTMLElement, index or instance of a model
   * representing this row
   */
  public native function removeRowCls(rowInfo:*, cls:String):void;

  /**
   * Traverses the tree rooted at this node in post-order mode, calling the passed function on the nodes at each level.
   * That is the function is called upon each node <strong>after</strong> being called on its children).
   *
   * <p>This method is used at each level down the cascade. Currently <a href="#!/api/Ext.Component" rel="Ext.Component" class="docClass">Component</a>s
   * and <a href="#!/api/Ext.data.TreeModel" rel="Ext.data.TreeModel" class="docClass">TreeModel</a>s are queryable.</p>
   *
   * <p>If you have tree-structured data, you can make your nodes queryable, and use ComponentQuery on them.</p>
   * @param selector A ComponentQuery selector used to filter candidate nodes before calling the function.
   * An empty string matches any node.
   * @param fn The function to call. Return <code>false</code> to aborl the traverse.
   * @param {Object} fn.node The node being visited.
   * @param scope The context (<code>this</code> reference) in which the function is executed.
   * @param extraArgs A set of arguments to be appended to the function's argument list to pass down extra data known to the caller
   * <strong>after</strong> the node being visited.
   */
  public native function visitPostOrder(selector:Object, fn:Function, scope:Object = null, extraArgs:Array = null):void;

  /**
   * Traverses the tree rooted at this node in pre-order mode, calling the passed function on the nodes at each level.
   * That is the function is called upon each node <strong>before</strong> being called on its children).
   *
   * <p>This method is used at each level down the cascade. Currently <a href="#!/api/Ext.Component" rel="Ext.Component" class="docClass">Component</a>s
   * and <a href="#!/api/Ext.data.TreeModel" rel="Ext.data.TreeModel" class="docClass">TreeModel</a>s are queryable.</p>
   *
   * <p>If you have tree-structured data, you can make your nodes queryable, and use ComponentQuery on them.</p>
   * @param selector A ComponentQuery selector used to filter candidate nodes before calling the function.
   * An empty string matches any node.
   * @param fn The function to call. Return <code>false</code> to aborl the traverse.
   * @param {Object} fn.node The node being visited.
   * @param scope The context (<code>this</code> reference) in which the function is executed.
   * @param extraArgs A set of arguments to be appended to the function's argument list to pass down extra data known to the caller
   * <strong>after</strong> the node being visited.
   */
  public native function visitPreOrder(selector:Object, fn:Function, scope:Object = null, extraArgs:Array = null):void;
}
}