package ext.view.events {
import ext.event.Event;
import ext.view.DataView;
import net.jangaroo.ext.FlExtEvent;

[Uses("net.jangaroo.ext.FlExtEvent")]
public class DataView_eEvent extends net.jangaroo.ext.FlExtEvent {
  public static const __PARAMETER_SEQUENCE__:Array;

  /**
   * "Fires before the click event on the container is processed. Returns false to cancel the default action.
   * @see ext.view.DataView
   * @eventType onBeforeContainerClick
   */
  public static const BEFORE_CONTAINER_CLICK:String = "onBeforeContainerClick";

  /**
   * "Fires before the contextmenu event on the container is processed. Returns false to cancel the default action.
   * @see ext.view.DataView
   * @eventType onBeforeContainerContextMenu
   */
  public static const BEFORE_CONTAINER_CONTEXT_MENU:String = "onBeforeContainerContextMenu";

  /**
   * "Fires before the dblclick event on the container is processed. Returns false to cancel the default action.
   * @see ext.view.DataView
   * @eventType onBeforeContainerDblclick
   */
  public static const BEFORE_CONTAINER_DBLCLICK:String = "onBeforeContainerDblclick";

  /**
   * "Fires before the keydown event on the container is processed. Returns false to cancel the default action.
   * @see ext.view.DataView
   * @eventType onBeforeContainerKeyDown
   */
  public static const BEFORE_CONTAINER_KEY_DOWN:String = "onBeforeContainerKeyDown";

  /**
   * "Fires before the keypress event on the container is processed. Returns false to cancel the default action.
   * @see ext.view.DataView
   * @eventType onBeforeContainerKeypress
   */
  public static const BEFORE_CONTAINER_KEYPRESS:String = "onBeforeContainerKeypress";

  /**
   * "Fires before the keyup event on the container is processed. Returns false to cancel the default action.
   * @see ext.view.DataView
   * @eventType onBeforeContainerKeyUp
   */
  public static const BEFORE_CONTAINER_KEY_UP:String = "onBeforeContainerKeyUp";

  /**
   * "Fires before the mousedown event on the container is processed. Returns false to cancel the default action.
   * @see ext.view.DataView
   * @eventType onBeforeContainerMouseDown
   */
  public static const BEFORE_CONTAINER_MOUSE_DOWN:String = "onBeforeContainerMouseDown";

  /**
   * "Fires before the mouseout event on the container is processed. Returns false to cancel the default action.
   * @see ext.view.DataView
   * @eventType onBeforeContainerMouseOut
   */
  public static const BEFORE_CONTAINER_MOUSE_OUT:String = "onBeforeContainerMouseOut";

  /**
   * "Fires before the mouseover event on the container is processed. Returns false to cancel the default action.
   * @see ext.view.DataView
   * @eventType onBeforeContainerMouseOver
   */
  public static const BEFORE_CONTAINER_MOUSE_OVER:String = "onBeforeContainerMouseOver";

  /**
   * "Fires before the mouseup event on the container is processed. Returns false to cancel the default action.
   * @see ext.view.DataView
   * @eventType onBeforeContainerMouseUp
   */
  public static const BEFORE_CONTAINER_MOUSE_UP:String = "onBeforeContainerMouseUp";

  /**
   * "Fires when the container is clicked.
   * @see ext.view.DataView
   * @eventType onContainerClick
   */
  public static const CONTAINER_CLICK:String = "onContainerClick";

  /**
   * "Fires when the container is right clicked.
   * @see ext.view.DataView
   * @eventType onContainerContextMenu
   */
  public static const CONTAINER_CONTEXT_MENU:String = "onContainerContextMenu";

  /**
   * "Fires when the container is double clicked.
   * @see ext.view.DataView
   * @eventType onContainerDblclick
   */
  public static const CONTAINER_DBLCLICK:String = "onContainerDblclick";

  /**
   * "Fires when a key is pressed down while the container is focused, and no item is currently selected.
   * @see ext.view.DataView
   * @eventType onContainerKeyDown
   */
  public static const CONTAINER_KEY_DOWN:String = "onContainerKeyDown";

  /**
   * "Fires when a key is pressed while the container is focused, and no item is currently selected.
   * @see ext.view.DataView
   * @eventType onContainerKeypress
   */
  public static const CONTAINER_KEYPRESS:String = "onContainerKeypress";

  /**
   * "Fires when a key is released while the container is focused, and no item is currently selected.
   * @see ext.view.DataView
   * @eventType onContainerKeyUp
   */
  public static const CONTAINER_KEY_UP:String = "onContainerKeyUp";

  /**
   * "Fires when there is a mousedown on the container
   * @see ext.view.DataView
   * @eventType onContainerMouseDown
   */
  public static const CONTAINER_MOUSE_DOWN:String = "onContainerMouseDown";

  /**
   * "Fires when you move the mouse out of the container.
   * @see ext.view.DataView
   * @eventType onContainerMouseOut
   */
  public static const CONTAINER_MOUSE_OUT:String = "onContainerMouseOut";

  /**
   * "Fires when you move the mouse over the container.
   * @see ext.view.DataView
   * @eventType onContainerMouseOver
   */
  public static const CONTAINER_MOUSE_OVER:String = "onContainerMouseOver";

  /**
   * "Fires when there is a mouseup on the container
   * @see ext.view.DataView
   * @eventType onContainerMouseUp
   */
  public static const CONTAINER_MOUSE_UP:String = "onContainerMouseUp";

  public function DataView_eEvent(type:String, arguments:Array) {
    super(null, null);
  }

  public native function get source():ext.view.DataView;

  /**
   * The raw event object
   */
  public native function get e():ext.event.Event;
}
}