Ext.define("ext.Plugin", function(Plugin) {/*package ext {

/**
 * <p>A Plugin provides custom functionality for a component. The only requirement for
 * a valid plugin is that it contain an <code>init</code> method that accepts a reference of type <a href="#!/api/Ext.Component" rel="Ext.Component" class="docClass">Ext.Component</a>. When a component
 * is created, if any plugins are available, the component will call the init method on each plugin, passing a
 * reference to itself. Each plugin can then call methods or respond to events on the component as needed to provide
 * its functionality.</p>
 *
 * <p>Plugins can be added to component by either directly referencing the plugin instance:</p>
 *
 * <pre><code>plugins: [<a href="#!/api/Ext-method-create" rel="Ext-method-create" class="docClass">Ext.create</a>('<a href="#!/api/Ext.grid.plugin.CellEditing" rel="Ext.grid.plugin.CellEditing" class="docClass">Ext.grid.plugin.CellEditing</a>', {clicksToEdit: 1})],
 * </code></pre>
 *
 * <p>By using config object with ptype:</p>
 *
 * <pre><code>plugins: {ptype: 'cellediting', clicksToEdit: 1},
 * </code></pre>
 *
 * <p>Or with just a ptype:</p>
 *
 * <pre><code>plugins: ['cellediting', 'gridviewdragdrop'],
 * </code></pre>
 *
 * <p>See <a href="#!/api/Ext.enums.Plugin" rel="Ext.enums.Plugin" class="docClass">Ext.enums.Plugin</a> for list of all ptypes.</p>
 * @since 2.3.0
 *
 * @see ext.Component#plugins
 * @see ext.ComponentMgr#registerPlugin()
 * @see ext.ComponentMgr#createPlugin()
 * /
public interface Plugin {

  /**
   * The init method is invoked after initComponent method has been run for the client Component.
   *
   * <p>The supplied implementation is empty. Subclasses should perform plugin initialization, and set up bidirectional
   * links between the plugin and its client Component in their own implementation of this method.</p>
   * @param client The client Component which owns this plugin.
   * /
  function init(client:Component):void;

}
}

============================================== Jangaroo part ==============================================*/
    return {};
});
