Ext.define("ext.grid.plugin.events.GridViewDragDropPlugin_node_data_overModel_dropPosition_dropHandlersEvent", function(GridViewDragDropPlugin_node_data_overModel_dropPosition_dropHandlersEvent) {/*package ext.grid.plugin.events {
import ext.data.Model;

import js.HTMLElement;

import net.jangaroo.ext.FlExtEvent;

public class GridViewDragDropPlugin_node_data_overModel_dropPosition_dropHandlersEvent extends FlExtEvent {
  public static const __PARAMETER_SEQUENCE__:Array =*/function __PARAMETER_SEQUENCE__$static_(){GridViewDragDropPlugin_node_data_overModel_dropPosition_dropHandlersEvent.__PARAMETER_SEQUENCE__=( ["node", "data", "overModel", "dropPosition", "dropHandlers", "eOpts"]);}/*;
  /**
   * "<strong>This event is fired through the <a href="#!/api/Ext.view.Table" rel="Ext.view.Table" class="docClass">GridView</a> and its owning
   * <a href="#!/api/Ext.grid.Panel" rel="Ext.grid.Panel" class="docClass">Grid</a>. You can add listeners to the grid or grid <a href="#!/api/Ext.grid.Panel-cfg-viewConfig" rel="Ext.grid.Panel-cfg-viewConfig" class="docClass">view config</a> object</strong>
   *
   * <p>Fired when a drop gesture has been triggered by a mouseup event in a valid drop
   * position in the grid view.</p>
   *
   * <p>Returning <code>false</code> to this event signals that the drop gesture was invalid and
   * animates the drag proxy back to the point from which the drag began.</p>
   *
   * <p>The dropHandlers parameter can be used to defer the processing of this event. For
   * example, you can force the handler to wait for the result of a message box
   * confirmation or an asynchronous server call (<em>see the details of the dropHandlers
   * property for more information</em>).</p>
   *
   * <pre><code>grid.on('beforedrop', function(node, data, overModel, dropPosition, dropHandlers) {
   *     // Defer the handling
   *     dropHandlers.wait = true;
   *     <a href="#!/api/Ext.MessageBox-method-confirm" rel="Ext.MessageBox-method-confirm" class="docClass">Ext.MessageBox.confirm</a>('Drop', 'Are you sure', function(btn){
   *         if (btn === 'yes') {
   *             dropHandlers.processDrop();
   *         } else {
   *             dropHandlers.cancelDrop();
   *         }
   *     });
   * });
   * </code></pre>
   *
   * <p>Any other return value continues with the data transfer operation unless the wait
   * property is set.</p>
   * @see ext.grid.plugin.GridViewDragDropPlugin
   * @eventType onBeforeDrop
   * /
  public static const BEFORE_DROP:String = "onBeforeDrop";

  public*/ function GridViewDragDropPlugin_node_data_overModel_dropPosition_dropHandlersEvent$(type/*:String*/, arguments/*:Array*/) {
    net.jangaroo.ext.FlExtEvent.prototype.constructor.call(this,type, arguments);
  }/*

  /**
   * The <a href="#!/api/Ext.view.Table" rel="Ext.view.Table" class="docClass">grid view</a> node <strong>if any</strong> over
   * which the cursor was positioned.
   * /
  public native function get node():HTMLElement;

  /**
   * The data object gathered at mousedown time by the
   * cooperating <a href="#!/api/Ext.dd.DragZone" rel="Ext.dd.DragZone" class="docClass">DragZone</a>'s <a href="#!/api/Ext.dd.DragZone-method-getDragData" rel="Ext.dd.DragZone-method-getDragData" class="docClass">getDragData</a> method.  It contains the following properties:
   * <ul>
   *   <li><code>copy</code> : Boolean
   * The value of <a href="#!/api/Ext.grid.plugin.DragDrop-cfg-copy" rel="Ext.grid.plugin.DragDrop-cfg-copy" class="docClass">copy</a>.  Or <code>true</code> if
   * <a href="#!/api/Ext.grid.plugin.DragDrop-cfg-allowCopy" rel="Ext.grid.plugin.DragDrop-cfg-allowCopy" class="docClass">allowCopy</a> is true <strong>and</strong> the control key was pressed as the drag
   * operation began.
   *   </li>
   *   <li><code>view</code> : ext.view.TableView
   * The source grid view from which the drag
   * originated
   *   </li>
   *   <li><code>ddel</code> : js.HTMLElement
   * The drag proxy element which moves with the cursor
   *   </li>
   *   <li><code>item</code> : js.HTMLElement
   * The grid view node upon which the mousedown event
   * was registered
   *   </li>
   *   <li><code>records</code> : Array
   * An Array of Models representing the
   * selected data being dragged from the source grid view
   *   </li>
   * </ul>
   * /
  public native function get data():Object;

  /**
   * The Model over which the drop gesture took place
   * /
  public native function get overModel():Model;

  /**
   * <code>"before"</code> or <code>"after"</code> depending on whether the
   * cursor is above or below the mid-line of the node.
   * /
  public native function get dropPosition():String;

  /**
   * This parameter allows the developer to control when the drop action takes place.
   * It is useful if any asynchronous processing needs to be completed before
   * performing the drop. This object has the following properties:
   * <ul>
   *   <li><code>wait</code> : Boolean
   * Indicates whether the drop should be deferred.
   * Set this property to true to defer the drop.
   *   </li>
   *   <li><code>processDrop</code> : Function
   * A function to be called to complete
   * the drop operation.
   *   </li>
   *   <li><code>cancelDrop</code> : Function
   * A function to be called to cancel the
   * drop operation.
   *   </li>
   * </ul>
   * /
  public native function get dropHandlers():Object;
}
}

============================================== Jangaroo part ==============================================*/
    return {
      extend: "net.jangaroo.ext.FlExtEvent",
      constructor: GridViewDragDropPlugin_node_data_overModel_dropPosition_dropHandlersEvent$,
      statics: {
        __PARAMETER_SEQUENCE__: undefined,
        BEFORE_DROP: "onBeforeDrop",
        __initStatics__: function() {
          __PARAMETER_SEQUENCE__$static_();
        }
      },
      requires: ["net.jangaroo.ext.FlExtEvent"]
    };
});
