Ext.define("ext.util.events.Collection_detailsEvent", function(Collection_detailsEvent) {/*package ext.util.events {
import ext.util.Collection;

import net.jangaroo.ext.FlExtEvent;

public class Collection_detailsEvent extends FlExtEvent {
  public static const __PARAMETER_SEQUENCE__:Array =*/function __PARAMETER_SEQUENCE__$static_(){Collection_detailsEvent.__PARAMETER_SEQUENCE__=( ["collection", "details", "eOpts"]);}/*;
  /**
   * "Fires after items have been added to the collection.
   *
   * <p>All <code><a href="#!/api/Ext.util.Collection-event-add" rel="Ext.util.Collection-event-add" class="docClass">add</a></code> and <code><a href="#!/api/Ext.util.Collection-event-remove" rel="Ext.util.Collection-event-remove" class="docClass">remove</a></code> events occur between
   * <code><a href="#!/api/Ext.util.Collection-event-beginupdate" rel="Ext.util.Collection-event-beginupdate" class="docClass">beginupdate</a></code> and <code><a href="#!/api/Ext.util.Collection-event-endupdate" rel="Ext.util.Collection-event-endupdate" class="docClass">endupdate</a></code>
   * events so it is best to do only the minimal amount of work in response to these
   * events and move the more expensive side-effects to an <code>endupdate</code> listener.</p>
   * @since 5.0.0
   * @see ext.util.Collection
   * @eventType onAdd
   * /
  public static const ADD:String = "onAdd";
  /**
   * "This event fires before an item change is reflected in the collection. This event
   * is always followed by an <code>itemchange</code> event and, depending on the change, possibly
   * an <code>add</code>, <code>remove</code> and/or <code>updatekey</code> event.
   * @since 5.0.0
   * @see ext.util.Collection
   * @eventType onBeforeItemChange
   * /
  public static const BEFORE_ITEM_CHANGE:String = "onBeforeItemChange";
  /**
   * "This event fires after an item change is reflected in the collection. This event
   * always follows a <code>beforeitemchange</code> event and its corresponding <code>add</code>, <code>remove</code>
   * and/or <code>updatekey</code> events.
   * @since 5.0.0
   * @see ext.util.Collection
   * @eventType onItemChange
   * /
  public static const ITEM_CHANGE:String = "onItemChange";
  /**
   * "Fires after items have been removed from the collection. Some properties of this
   * object may not be present if calculating them is deemed too expensive. These are
   * marked as "optional".
   *
   * <p>All <code><a href="#!/api/Ext.util.Collection-event-add" rel="Ext.util.Collection-event-add" class="docClass">add</a></code> and <code><a href="#!/api/Ext.util.Collection-event-remove" rel="Ext.util.Collection-event-remove" class="docClass">remove</a></code> events occur between
   * <code><a href="#!/api/Ext.util.Collection-event-beginupdate" rel="Ext.util.Collection-event-beginupdate" class="docClass">beginupdate</a></code> and <code><a href="#!/api/Ext.util.Collection-event-endupdate" rel="Ext.util.Collection-event-endupdate" class="docClass">endupdate</a></code>
   * events so it is best to do only the minimal amount of work in response to these
   * events and move the more expensive side-effects to an <code>endupdate</code> listener.</p>
   * @since 5.0.0
   * @see ext.util.Collection
   * @eventType onRemove
   * /
  public static const REMOVE:String = "onRemove";
  /**
   * "Fires after the key for an item has changed.
   * @since 5.0.0
   * @see ext.util.Collection
   * @eventType onUpdateKey
   * /
  public static const UPDATE_KEY:String = "onUpdateKey";

  public*/ function Collection_detailsEvent$(type/*:String*/, arguments/*:Array*/) {
    net.jangaroo.ext.FlExtEvent.prototype.constructor.call(this,type, arguments);
  }/*

  /**
   * The collection being modified.
   * /
  public native function get collection():Collection;

  /**
   * An object describing the addition.
   * <ul>
   *   <li><code>at</code> : Number
   * The index in the collection where the add occurred.
   *   </li>
   *   <li><code>atItem</code> : Object
   * The item after which the new items were inserted or
   * <code>null</code> if at the beginning of the collection.
   *   </li>
   *   <li><code>items</code> : Array
   * The items that are now added to the collection.
   *   </li>
   *   <li><code>keys</code> : Array (optional)
   * If available this array holds the keys (extracted by
   * <code>getKey</code>) for each item in the <code>items</code> array.
   *   </li>
   *   <li><code>next</code> : Object (optional)
   * If more <code><a href="#!/api/Ext.util.Collection-event-add" rel="Ext.util.Collection-event-add" class="docClass">add</a></code> events are in queue
   * to be delivered this is a reference to the <code>details</code> instance for the next
   * <code><a href="#!/api/Ext.util.Collection-event-add" rel="Ext.util.Collection-event-add" class="docClass">add</a></code> event. This will only be the case when the collection is
   * sorted as the new items often need to be inserted at multiple locations to maintain
   * the sort. In this case, all of the new items have already been added not just those
   * described by the first <code><a href="#!/api/Ext.util.Collection-event-add" rel="Ext.util.Collection-event-add" class="docClass">add</a></code> event.
   *   </li>
   *   <li><code>replaced</code> : Object (optional)
   * If this addition has a corresponding set of
   * <code><a href="#!/api/Ext.util.Collection-event-remove" rel="Ext.util.Collection-event-remove" class="docClass">remove</a></code> events this reference holds the <code>details</code> object for
   * the first <code>remove</code> event. That <code>details</code> object may have a <code>next</code> property if there
   * are multiple associated <code>remove</code> events.
   *   </li>
   * </ul>
   * /
  public native function get details():Object;
}
}

============================================== Jangaroo part ==============================================*/
    return {
      extend: "net.jangaroo.ext.FlExtEvent",
      constructor: Collection_detailsEvent$,
      statics: {
        __PARAMETER_SEQUENCE__: undefined,
        ADD: "onAdd",
        BEFORE_ITEM_CHANGE: "onBeforeItemChange",
        ITEM_CHANGE: "onItemChange",
        REMOVE: "onRemove",
        UPDATE_KEY: "onUpdateKey",
        __initStatics__: function() {
          __PARAMETER_SEQUENCE__$static_();
        }
      },
      requires: ["net.jangaroo.ext.FlExtEvent"]
    };
});
